local os = GameApp.GetOS()
if os == 0 then
 dofile "scene\\common_ai.lua"
elseif os == 1 then
 require "common_ai"
end

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0

local scriptTimer = 0
local script3Timer = 0
local script4Timer = 0
local scriptDelay = 5

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
end

function DeInit(self)
end

function Update(self)
	UpdateFSM(self)
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsAchieved() then			-- win conditon
		self:WinGame(humanPlayerIndex)
	end
	
	if humanPlayer:GetCurrentHP() <= 0 then   -- lose condition
		self:LoseGame()
	end
end

function UpdateFSM(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	Objectives(self)
	DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd and current >= scriptTimer + scriptDelay then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,bh,towerTypes)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
		scriptTimer = GameApp.GetServerFrameCount()
	end
end
