-- Mission 1: Unwelcome Guests

VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local tutorialTimer = 999999

local scriptTimer = 0 
local scriptDelay = 5
local gridSwitched = false
local hpSwitched = 0
local towerLimit = false
local towerLimitBlink = false
local towerLimitTimer = 0
local disableSettings = true

local lastCam = vector3(0,0,0)
local tutorial = false

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	waves = {1,1,1,2,2,4}
	towerTypes = {1}
	RefreshUnitCost(self,enemyPlayer,unitCost)
	CheckRace(self,enemyPlayer,eState)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	building.maxTowerCount = 3
	building.defensiveTowerLimit = 2
	building.switchToDefensiveTowerLimit = 2
	building.radius = 190
	tutorial = GameApp.GetStartTutorialMode()
	self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	self:DisableUnitType(UnitType.DWARF)
	self:DisableUnitType(UnitType.WIZARD)
	self:DisableUnitType(UnitType.WIZARD_HERO)
	self:DisableUnitType(UnitType.GRIFFONRIDER_HERO)
	self:DisableUnitType(UnitType.ELVENARCHER_HERO)
	self:DisableUnitType(UnitType.THIEF_HERO)
	self:DisableUnitType(UnitType.CLERIC_HERO)
	self:DisableUnitType(UnitType.WARRIOR_HERO)
	self:DisableUnitType(UnitType.GUARDSMAN_HERO)
	self:DisableUnitType(UnitType.DWARF_HERO)
	
	self:DisableUnitType(UnitType.HUMAN_BLOCK)
	self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	
	self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	if tutorial then 
		self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_01_01) 
	else
		self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_01_05)
	end
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_FOXWALDE_ARMY_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_FOXWALDE_ARMY_NAME)
    GameApp.DisableXPSystem(true)
	--self:UnlockUnit(t.hu_spear)
	--self:UnlockUnit(t.hu_ballista)
	--self:UnlockUnit(0)
	--self:UnlockUnit(1)
	--self:UnlockUnit(2)
	--self:UnlockUnit(3)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if current < 30 and disableSettings then
		GameApp.SetTutorialMode(true)
		DisableMenus("all")
		humanPlayer:SetMaxTowerUpgrade(0)
		disableSettings = false
	end
end

function Objectives(self)
	--self:Print(tostring(tutorial))
	local obj1 = self:GetObjective(0)
		if not self:IsStoryDialogActive() then
			if enemyPlayer:GetCurrentHP() <= 0 and dialog.dialogEnemyHp == 2 then
				if tutorial then 
					self:SetObjectiveText(4, 2, LocID.LOC_OBJ_LEVEL_01_05)
				else
					self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_01_05)
				end
				self:DisableInput()
				humanPlayer:StopAllUnit()
				self:DisplayDialog(LocID.STORY_HU_LEVEL_01_INGAME_60, StoryChar.ADVISOR,"story_hu_level_01_ingame_60")
				humanPlayer:SetInvulnerable (true)
				enemyPlayer:SetInvulnerable (true)
				dialog.dialogEnemyHp = 3
			elseif dialog.dialogEnemyHp == 3 then
				self:DisplayDialog(LocID.STORY_HU_LEVEL_01_INGAME_61, StoryChar.ADVISOR,"story_hu_level_01_ingame_61")
				dialog.dialogEnemyHp = 4
			elseif dialog.dialogEnemyHp == 4 then
				self:DisplayDialog(LocID.STORY_HU_LEVEL_01_INGAME_62, StoryChar.ADVISOR,"story_hu_level_01_ingame_62")
				dialog.dialogEnemyHp = 5
			elseif dialog.dialogEnemyHp == 5 then
				self:EnableInput()
				self:WinGame(humanPlayerIndex)
			end
		end	
	if towerLimit and towerLimitBlink then
		local current = GameApp.GetServerFrameCount()
		if current > towerLimitTimer + 220 then
			GameApp.SetBlink(false, GuiItemType.TOWERLIMIT, 0, vector3(0,0,0))
			towerLimitBlink = false
		end
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	HpDialog(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		--EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		--UpgradeTowers(self,enemyPlayer,building,eState,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 650
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1100
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 233
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	RepeatDialog(self,dialog,humanPlayer)
	-- start text
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			AiStop(self,upgrade,building,eState)
			self:DisableInput()
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_01, StoryChar.ADVISOR,"story_hu_level_01_ingame_01")
			dialog.dialogIndex = 1
			--dialog.dialogIndex = 8 --debug
		elseif dialog.dialogIndex == 1 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_02, StoryChar.ADVISOR,"story_hu_level_01_ingame_02")
			dialog.dialogIndex = 2
			GameApp.SetCamTutorialMode(true)
		elseif dialog.dialogIndex == 2 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_03, StoryChar.ADVISOR,"story_hu_level_01_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_04, StoryChar.ADVISOR,"story_hu_level_01_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_05, StoryChar.ADVISOR,"story_hu_level_01_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_06, StoryChar.ADVISOR,"story_hu_level_01_ingame_06")
			if tutorial then
				dialog.dialogIndex = 6
			else
				dialog.dialogIndex = 57
				DisableMenus("none")
				AiStart(self,upgrade,building,eState)
				dialog.dialogEnd = true
				scriptDelay = 15
				self:EnableInput()
			end
		elseif dialog.dialogIndex == 6 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_07, StoryChar.ADVISOR,"story_hu_level_01_ingame_07")
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_08, StoryChar.ADVISOR,"story_hu_level_01_ingame_08",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_08,"story_xbox_hu_level_01_ingame_08",LocID.STORY_PS3_HU_LEVEL_01_INGAME_08,"story_ps3_hu_level_01_ingame_08")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 8
			
		elseif dialog.dialogIndex == 8.1 then -- kamera mozgatasnal
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_09, StoryChar.ADVISOR,"story_hu_level_01_ingame_09",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_09,"story_xbox_hu_level_01_ingame_09",LocID.STORY_PS3_HU_LEVEL_01_INGAME_09,"story_ps3_hu_level_01_ingame_09")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 9
		
		elseif dialog.dialogIndex == 9.1 then -- kamera forgatasnal
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_10, StoryChar.ADVISOR,"story_hu_level_01_ingame_10",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_10,"story_xbox_hu_level_01_ingame_10",LocID.STORY_PS3_HU_LEVEL_01_INGAME_10,"story_ps3_hu_level_01_ingame_10")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 10
			
		elseif dialog.dialogIndex == 10.1 then -- kamera zoom utan
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_11, StoryChar.ADVISOR,"story_hu_level_01_ingame_11")
			dialog.repeatStart = false
			dialog.dialogIndex = 11
			GameApp.SetCamTutorialMode(false)
		elseif dialog.dialogIndex == 11 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_12, StoryChar.ADVISOR,"story_hu_level_01_ingame_12",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_12,"story_xbox_hu_level_01_ingame_12",LocID.STORY_PS3_HU_LEVEL_01_INGAME_12,"story_ps3_hu_level_01_ingame_12")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			self:EnableInput()
			dialog.dialogIndex = 13
			
		elseif gridSwitched and dialog.dialogIndex == 13 then -- grid bekapcsolasa utan
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_13, StoryChar.ADVISOR,"story_hu_level_01_ingame_13")
			dialog.dialogIndex = 14
			dialog.repeatStart = false
		elseif dialog.dialogIndex == 14 then 
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_14, StoryChar.ADVISOR,"story_hu_level_01_ingame_14")
			dialog.dialogIndex = 15
		elseif dialog.dialogIndex == 15 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_15, StoryChar.ADVISOR,"story_hu_level_01_ingame_15")
			self:MoveCameraTo(vector3(-240,0,0))
			dialog.dialogIndex = 16
		elseif dialog.dialogIndex == 16 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SAFE_ZONE_01, StoryChar.ADVISOR,"loc_tutorial_safe_zone_01")
			self:MoveCameraTo(vector3(240,0,0))
			dialog.dialogIndex = 16.1
		elseif dialog.dialogIndex == 16.1 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SAFE_ZONE_02, StoryChar.ADVISOR,"loc_tutorial_safe_zone_02")
			dialog.dialogIndex = 16.2
		elseif dialog.dialogIndex == 16.2 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SAFE_ZONE_03, StoryChar.ADVISOR,"loc_tutorial_safe_zone_03")
			dialog.dialogIndex = 16.3
		elseif dialog.dialogIndex == 16.3 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SAFE_ZONE_04, StoryChar.ADVISOR,"loc_tutorial_safe_zone_04")
			dialog.dialogIndex = 17
		elseif dialog.dialogIndex == 17 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_17, StoryChar.ADVISOR,"story_hu_level_01_ingame_17")
			self:MoveCameraTo(vector3(-80,-80,0))
			dialog.dialogIndex = 18
		elseif dialog.dialogIndex == 18 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_18, StoryChar.ADVISOR,"story_hu_level_01_ingame_18")
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_19, StoryChar.ADVISOR,"story_hu_level_01_ingame_19")
			dialog.dialogIndex = 20
		elseif dialog.dialogIndex == 20 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_20, StoryChar.ADVISOR,"story_hu_level_01_ingame_20",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_20,"story_xbox_hu_level_01_ingame_20",LocID.STORY_PS3_HU_LEVEL_01_INGAME_20,"story_ps3_hu_level_01_ingame_20")
			self:MoveCameraTo(vector3(-240,0,0))
			DisableMenus("tower")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			GameApp.SetBlink(true, GuiItemType.UNIT, UnitType.HUMAN_DAMAGE, vector3(0,0,0))
			dialog.dialogIndex = 21
		
		elseif dialog.dialogIndex == 21.1 then -- ha elohozta a torony epito menut
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_21, StoryChar.ADVISOR,"story_hu_level_01_ingame_21",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_21,"story_xbox_hu_level_01_ingame_21",LocID.STORY_PS3_HU_LEVEL_01_INGAME_21,"story_ps3_hu_level_01_ingame_21")
			dialog.dialogIndex = 22
		elseif dialog.dialogIndex == 22 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_22, StoryChar.ADVISOR,"story_hu_level_01_ingame_22",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_22,"story_xbox_hu_level_01_ingame_22",LocID.STORY_PS3_HU_LEVEL_01_INGAME_22,"story_ps3_hu_level_01_ingame_22")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			dialog.dialogIndex = 23

		elseif dialog.dialogIndex == 23 then
			local towerCount = humanPlayer:GetTowerCount() -- torony felepitve
			if towerCount > 0 then
				GameApp.SetBlink(false, GuiItemType.UNIT, UnitType.HUMAN_DAMAGE, vector3(0,0,0))
				ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_23, StoryChar.ADVISOR,"story_hu_level_01_ingame_23")
				dialog.repeatStart = false
				self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_01_02)
				dialog.dialogIndex = 24
			end
		
		elseif dialog.dialogIndex == 24 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_24, StoryChar.ADVISOR,"story_hu_level_01_ingame_24")
			self:MoveCameraTo(vector3(-80,-80,0))
			dialog.dialogIndex = 25
		elseif dialog.dialogIndex == 25 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_25, StoryChar.ADVISOR,"story_hu_level_01_ingame_25")
			self:MoveCameraTo(vector3(-40,-120,0))
			dialog.dialogIndex = 25.1
		elseif dialog.dialogIndex == 25.1 then
			ShowDialog(self,LocID.LOC_TUTORIAL_TOWER_RANGE_01, StoryChar.ADVISOR,"loc_tutorial_tower_range_01")
			dialog.dialogIndex = 26

		elseif dialog.dialogIndex == 26 then
			local towerCount = humanPlayer:GetTowerCount() -- +2 torony felepitve
			if towerCount > 2 then
				ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_26, StoryChar.ADVISOR,"story_hu_level_01_ingame_26")
				self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_01_02)
				dialog.dialogIndex = 27
			end
		elseif dialog.dialogIndex == 27 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_27, StoryChar.ADVISOR,"story_hu_level_01_ingame_27")
			dialog.dialogIndex = 28
		elseif dialog.dialogIndex == 28 then
			GameApp.SetBlink(true, GuiItemType.RESOURCE, 0, vector3(0,0,0))
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_28, StoryChar.ADVISOR,"story_hu_level_01_ingame_28")
			dialog.dialogIndex = 29
		elseif dialog.dialogIndex == 29 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_29, StoryChar.ADVISOR,"story_hu_level_01_ingame_29")
			dialog.dialogIndex = 30
		elseif dialog.dialogIndex == 30 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_30, StoryChar.ADVISOR,"story_hu_level_01_ingame_30")
			GameApp.SetBlink(false, GuiItemType.RESOURCE, 0, vector3(0,0,0))
			dialog.dialogIndex = 31
		elseif dialog.dialogIndex == 31 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_31, StoryChar.ADVISOR,"story_hu_level_01_ingame_31")
			dialog.dialogIndex = 32
			enemyPlayer:SendUnit(UnitType.GUARDSMAN)
		elseif dialog.dialogIndex == 32 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_32, StoryChar.ADVISOR,"story_hu_level_01_ingame_32")
			self:SetObjectiveText(2, 1, LocID.LOC_OBJ_LEVEL_01_03)
			self:MoveCameraTo(vector3(200,-200,0))
			dialog.dialogIndex = 33
		elseif dialog.dialogIndex == 33 then
			local unitCount = enemyPlayer:GetUnitCount() -- meghalt-e az enemy
			if unitCount == 0 then
				ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_33, StoryChar.ADVISOR,"story_hu_level_01_ingame_33")
				dialog.dialogIndex = 34
			end
		elseif dialog.dialogIndex == 34 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_34, StoryChar.ADVISOR,"story_hu_level_01_ingame_34")
			dialog.dialogIndex = 35
		elseif dialog.dialogIndex == 35 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_35, StoryChar.ADVISOR,"story_hu_level_01_ingame_35")
			dialog.dialogIndex = 35.1
		elseif dialog.dialogIndex == 35.1 then
			ShowDialog(self,LocID.LOC_TUTORIAL_TIME_ACCELERATION, StoryChar.ADVISOR,"loc_tutorial_time_acceleration",LocID.LOC_XBOX_TUTORIAL_TIME_ACCELERATION,"loc_xbox_tutorial_time_acceleration",LocID.LOC_PS3_TUTORIAL_TIME_ACCELERATION, "loc_ps3_tutorial_time_acceleration")
			dialog.dialogIndex = 36
		elseif dialog.dialogIndex == 36 then
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			scriptDelay = 15
			tutorialTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 37
			self:SetTimer(0,3600,true,LocID.LOC_TIMER_HU_01_ATTACK)
		
		elseif current >= tutorialTimer + 1800 and dialog.dialogIndex == 37 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_36, StoryChar.ADVISOR,"story_hu_level_01_ingame_36")
			dialog.dialogIndex = 38
		elseif current >= tutorialTimer + 1800*2-300 and dialog.dialogIndex == 38  then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_37, StoryChar.ADVISOR,"story_hu_level_01_ingame_37")
			dialog.dialogIndex = 39	
		elseif current >= tutorialTimer + 1800*2 and dialog.dialogIndex == 39  then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_38, StoryChar.ADVISOR,"story_hu_level_01_ingame_38")
			dialog.dialogIndex = 40
			self:SetObjectiveText(2, 2, LocID.LOC_OBJ_LEVEL_01_03)
		elseif dialog.dialogIndex == 40 then
			AiStop(self,upgrade,building,eState)
			attack.attackTimer = 99999
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_39, StoryChar.ADVISOR,"story_hu_level_01_ingame_39")
			self:SetObjectiveText(3, 1, LocID.LOC_OBJ_LEVEL_01_04)
			dialog.dialogIndex = 40.1
		elseif dialog.dialogIndex == 40.1 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_40, StoryChar.ADVISOR,"story_hu_level_01_ingame_40")
			dialog.dialogIndex = 41
		elseif dialog.dialogIndex == 41 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_41, StoryChar.ADVISOR,"story_hu_level_01_ingame_41")
			dialog.dialogIndex = 42
		elseif dialog.dialogIndex == 42 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_42, StoryChar.ADVISOR,"story_hu_level_01_ingame_42")
			dialog.dialogIndex = 43
		elseif dialog.dialogIndex == 43 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_43, StoryChar.ADVISOR,"story_hu_level_01_ingame_43")
			dialog.dialogIndex = 44
		elseif dialog.dialogIndex == 44 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_44, StoryChar.ADVISOR,"story_hu_level_01_ingame_44")
			dialog.dialogIndex = 45
		elseif dialog.dialogIndex == 45 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_45, StoryChar.ADVISOR,"story_hu_level_01_ingame_45")
			dialog.dialogIndex = 46
		elseif dialog.dialogIndex == 46 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_46, StoryChar.ADVISOR,"story_hu_level_01_ingame_46",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_46,"story_xbox_hu_level_01_ingame_46",LocID.STORY_PS3_HU_LEVEL_01_INGAME_46,"story_ps3_hu_level_01_ingame_46")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			dialog.dialogIndex = 47
			GameApp.DisableUnitMenu(false)
			--GameApp.DisableEcoMenu(false)
		
		elseif dialog.dialogIndex == 47.1 then 		-- unitmenu
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_47, StoryChar.ADVISOR,"story_hu_level_01_ingame_47",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_47,"story_xbox_hu_level_01_ingame_47",LocID.STORY_PS3_HU_LEVEL_01_INGAME_47,"story_ps3_hu_level_01_ingame_47")
			GameApp.SetBlink(true, GuiItemType.UNIT, UnitType.GUARDSMAN, vector3(0,0,0))
			dialog.repeatStart = false
			dialog.dialogIndex = 48
		elseif dialog.dialogIndex == 48 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_48, StoryChar.ADVISOR,"story_hu_level_01_ingame_48",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_48,"story_xbox_hu_level_01_ingame_48",LocID.STORY_PS3_HU_LEVEL_01_INGAME_48,"story_ps3_hu_level_01_ingame_48")
			dialog.dialogIndex = 49
		elseif dialog.dialogIndex == 49 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_49, StoryChar.ADVISOR,"story_hu_level_01_ingame_49",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_49,"story_xbox_hu_level_01_ingame_49",LocID.STORY_PS3_HU_LEVEL_01_INGAME_49,"story_ps3_hu_level_01_ingame_49")
			dialog.dialogIndex = 50
		elseif dialog.dialogIndex == 50 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_50, StoryChar.ADVISOR,"story_hu_level_01_ingame_50",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_50,"story_xbox_hu_level_01_ingame_50",LocID.STORY_PS3_HU_LEVEL_01_INGAME_50,"story_ps3_hu_level_01_ingame_50")
			dialog.dialogIndex = 51
		elseif dialog.dialogIndex == 51 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_51, StoryChar.ADVISOR,"story_hu_level_01_ingame_51",LocID.STORY_XBOX_HU_LEVEL_01_INGAME_51,"story_xbox_hu_level_01_ingame_51",LocID.STORY_PS3_HU_LEVEL_01_INGAME_51,"story_ps3_hu_level_01_ingame_51")
			GameApp.SetBlink(false, GuiItemType.UNIT, UnitType.GUARDSMAN, vector3(0,0,0))
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			dialog.dialogIndex = 52
		elseif dialog.dialogIndex == 52 then
			local unitCount = humanPlayer:GetLaunchedUnitCount() 
			if unitCount > 0 then
				ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_52, StoryChar.ADVISOR,"story_hu_level_01_ingame_52")
				self:SetObjectiveText(3, 2, LocID.LOC_OBJ_LEVEL_01_04)
				dialog.repeatStart = false
				dialog.dialogIndex = 53
			end
		elseif dialog.dialogIndex == 53 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_53, StoryChar.ADVISOR,"story_hu_level_01_ingame_53")
			GameApp.SetBlink(true, GuiItemType.UNITLIMIT, 0, vector3(0,0,0))
			dialog.dialogIndex = 54
		elseif dialog.dialogIndex == 54 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_54, StoryChar.ADVISOR,"story_hu_level_01_ingame_54")
			dialog.dialogIndex = 54.1
		elseif dialog.dialogIndex == 54.1 then
			ShowDialog(self,LocID.LOC_TUTORIAL_HP_BAR_01, StoryChar.ADVISOR,"loc_tutorial_hp_bar_01",LocID.LOC_XBOX_TUTORIAL_HP_BAR_01,"loc_xbox_tutorial_hp_bar_01",LocID.LOC_PS3_TUTORIAL_HP_BAR_01,"loc_ps3_tutorial_hp_bar_01")
			GameApp.SetBlink(false, GuiItemType.UNITLIMIT, 0, vector3(0,0,0))
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			dialog.dialogIndex = 54.11
		elseif dialog.dialogIndex == 54.11 then
			if hpSwitched >=1 then
				dialog.dialogIndex = 54.2
			end
		elseif dialog.dialogIndex == 54.2 then
			ShowDialog(self,LocID.LOC_TUTORIAL_HP_BAR_02, StoryChar.ADVISOR,"loc_tutorial_hp_bar_02",LocID.LOC_XBOX_TUTORIAL_HP_BAR_02,"loc_xbox_tutorial_hp_bar_02",LocID.LOC_PS3_TUTORIAL_HP_BAR_02,"loc_ps3_tutorial_hp_bar_02")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			dialog.dialogIndex = 54.21
		elseif dialog.dialogIndex == 54.21 then
			if hpSwitched >=2 then
				dialog.dialogIndex = 54.3
			end
		elseif dialog.dialogIndex == 54.3 then
			ShowDialog(self,LocID.LOC_TUTORIAL_HP_BAR_03, StoryChar.ADVISOR,"loc_tutorial_hp_bar_03",LocID.LOC_XBOX_TUTORIAL_HP_BAR_03,"loc_xbox_tutorial_hp_bar_03",LocID.LOC_PS3_TUTORIAL_HP_BAR_03,"loc_ps3_tutorial_hp_bar_03")
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.repeatStart = true
			dialog.dialogIndex = 54.4
		elseif dialog.dialogIndex == 54.4 then
			if hpSwitched >=3 then
				dialog.dialogIndex = 55
				dialog.repeatStart = false
			end
		elseif dialog.dialogIndex == 55 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_55, StoryChar.ADVISOR,"story_hu_level_01_ingame_55")
			dialog.dialogIndex = 56
		elseif dialog.dialogIndex == 56 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_56, StoryChar.ADVISOR,"story_hu_level_01_ingame_56")
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_01_01)
			self:SetObjectiveText(4, 1, LocID.LOC_OBJ_LEVEL_01_05)
			dialog.dialogIndex = 57
		elseif dialog.dialogIndex == 57 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_57, StoryChar.ADVISOR,"story_hu_level_01_ingame_57")
			dialog.dialogIndex = 58
			attack.attackTimer = GameApp.GetServerFrameCount()
			AiStart(self,upgrade,building,eState)
		elseif dialog.dialogIndex >= 36 and towerLimit == false and tutorial then	
			local towerCount = humanPlayer:GetTowerCount()
			if towerCount >= 6 then
				ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_65, StoryChar.ADVISOR,"story_hu_level_01_ingame_65")
				GameApp.SetBlink(true, GuiItemType.TOWERLIMIT, 0, vector3(0,0,0))
				towerLimitTimer = GameApp.GetServerFrameCount()
				dialog.repeatStart = false
				towerLimitBlink = true
				towerLimit = true
			end
		end
	end
end

function GridVisibleChanged(self, visible)
	if dialog.dialogIndex <= 13 and visible then
		gridSwitched = true
	end
end

function BuildTowerMenuActivated( self )
	if dialog.dialogIndex == 21 then
		dialog.dialogIndex = 21.1
	end
end

function SkipStoryActivated(self)
	if tutorial then
		if dialog.dialogIndex < 11 then
			dialog.dialogIndex = 11
		end
	else
		if dialog.dialogIndex < 56 then
			dialog.dialogIndex = 57
			DisableMenus("none")
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			scriptDelay = 15
			self:EnableInput()
		end
	end
end

function UnitShopMenuActivated(self)
	if dialog.dialogIndex == 47 then
		dialog.dialogIndex = 47.1
	end
end

function CameraMoveActivated(self)
	if dialog.dialogIndex == 8 then
		dialog.dialogIndex = 8.1
	end
end

function CameraZoomActivated(self)
	if dialog.dialogIndex == 10 then
		dialog.dialogIndex = 10.1
	end
end

function CameraDirActivated(self)
	if dialog.dialogIndex == 9 then
		dialog.dialogIndex = 9.1
	end
end

function ShowHPActivated(self,hpState)
	if hpSwitched == 0 and hpState >= 1 then
		hpSwitched = hpState
	end
	if hpSwitched == 1 and hpState >= 2 then
		hpSwitched = hpState
	end
	if hpSwitched == 2 and (hpState == 0 or hpState >= 3) then 
		hpSwitched = 3
	end
	--if hpSwitched == 3 and hpState >= 4 then 
	--	hpSwitched = hpState
	--end
end

function HpDialog(self)
	if not self:IsStoryDialogActive() and humanPlayer:GetCurrentHP() <= 0.95 and dialog.dialogHumanHp == 0 and tutorial then
		ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_63, StoryChar.ADVISOR,"story_hu_level_01_ingame_63")
		dialog.dialogHumanHp = 1
	end
	if not self:IsStoryDialogActive() and dialog.dialogHumanHp == 1 and tutorial then
		ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_64, StoryChar.ADVISOR,"story_hu_level_01_ingame_64")
		dialog.dialogHumanHp = 2
	end

	if not self:IsStoryDialogActive() and enemyPlayer:GetCurrentHP() <= 0.75 and dialog.dialogEnemyHp == 0 then
		ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_58, StoryChar.ADVISOR,"story_hu_level_01_ingame_58")
		dialog.dialogEnemyHp = 1
	end
	if not self:IsStoryDialogActive() and enemyPlayer:GetCurrentHP() <= 0.25 and dialog.dialogEnemyHp == 1 then
		ShowDialog(self,LocID.STORY_HU_LEVEL_01_INGAME_59, StoryChar.ADVISOR,"story_hu_level_01_ingame_59")
		dialog.dialogEnemyHp = 2
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end

function KeyDown(self, key)
	--self:Print(key)
	--if key == 66 then
	--	dialog.dialogIndex = 54
	--end
end