-- Mission 2: Voices from the deep

--local os = GameApp.GetOS()
--if os == 0 then
-- dofile "scene\\common_ai.lua"
--elseif os == 1 or os == 2 then
--require "common_ai"
--end
VisionLua.LoadScript("scene\\common_ai.lua")

levelState = 
{
	state1 = 0,
	state2 = 1,
	state3 = 2,
}

state = 0

local mineElevatorModelName = "graphic/environment/Human/hu_mine_elevator.MODEL"
local mineElevator2ModelName = "graphic/environment/Human/hu_open_mine.MODEL"
local animatedMineElevatorModelName = "graphic/environment/Human/hu_mine_elevator_physics.MODEL"
local animatedMineElevator2ModelName = "graphic/environment/Human/hu_open_mine_physics.MODEL"
local crashedMineElevatorModelName = "graphic/environment/Human/hu_mine_elevator_physics_after.MODEL"
local crashedMineElevator2ModelName = "graphic/environment/Human/hu_open_mine_physics_after.MODEL"
local mineElevatorAnimationName = "collapse"
local mineElevator2AnimationName = "collapse"
local crashParticleEffectName = "graphic/effect/beast_tower1_explosion.xml"
local elevator1Name = "hu_03_elevator_1"
local elevator1FireName = "hu_03_elevator_1_fire"
local elevator1LightName = "hu_03_elevator_1_light"
local elevator2Name = "hu_03_mine_1"
local elevator2FireName = "hu_03_mine_1_fire"
local elevator2LightName = "hu_03_mine_1_light"
local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local objState = 0
local zombieTimer = 0
local prevDialog = 0

local scriptTimer = 0
local scriptDelay = 5
local tutorial = false

local disableSettings = true

function Init(self)
	tutorial = GameApp.GetStartTutorialMode()
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	startDialog = GameApp.GetServerFrameCount()
	waves = {1,2,2,2,3,4,5,5,5,6}
	towerTypes = {1,5}
	building.maxTowerCount = 5
	building.defensiveTowerLimit = 3
	building.switchToDefensiveTowerLimit = 3
	zombieTimer = 99999
	objState = 0
	self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	self:DisableUnitType(UnitType.DWARF)
	self:DisableUnitType(UnitType.WIZARD)
	self:DisableUnitType(UnitType.WIZARD_HERO)
	self:DisableUnitType(UnitType.GRIFFONRIDER_HERO)
	self:DisableUnitType(UnitType.ELVENARCHER_HERO)
	self:DisableUnitType(UnitType.THIEF_HERO)
	self:DisableUnitType(UnitType.CLERIC_HERO)
	self:DisableUnitType(UnitType.WARRIOR_HERO)
	self:DisableUnitType(UnitType.GUARDSMAN_HERO)
	self:DisableUnitType(UnitType.DWARF_HERO)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	
	self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)	
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:UnlockUnit(UnitType.HUMAN_BLOCK)
	self:UnlockEconomy(UpgradeType.CHEAPER_UNITS)
	self:UnlockEconomy(UpgradeType.CHEAPER_TOWERS)
	
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)
	if obj1 ~= nil then
		obj1:Activate(true)
	end
	if obj2 ~= nil then
		obj2:Activate(true)
	end

	enemyPlayer:SetAttackable(false)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_FOXWALDE_ARMY_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_FOXWALDE_ARMY_NAME)
	
	local player2 = GameApp.GetPlayer(2)
	player2:SetDescriptionLocID(LocID.LOC_NMY_MINES_DESC)
	player2:SetNameLocID(LocID.LOC_NMY_MINES_NAME)
	player2:SetBaseIconFileName("graphic/gui/ingame/human/icon_base_human_01.dds")
	player2:SetDisabledBaseIconFileName("graphic/gui/ingame/human/icon_base_human_01.dds")
	
	local player3 = GameApp.GetPlayer(3)
	player3:SetNameLocID(LocID.LOC_NMY_MINES_NAME)
	player3:SetDescriptionLocID(LocID.LOC_NMY_MINES_DESC)
	player3:SetBaseIconFileName("graphic/gui/ingame/human/icon_base_human_02.dds")
	player3:SetDisabledBaseIconFileName("graphic/gui/ingame/human/icon_base_human_02.dds")
	
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_02_01)
	GameApp.DisableXPSystem(true) 
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if current < 60 and disableSettings then
		GameApp.DisableEcoMenu(true)
		GameApp.DisableSpellMenu(true)
		humanPlayer:SetMaxTowerUpgrade(0)
		disableSettings = false
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)
	if obj1:IsAchieved() and objState == 0 then
		objState = 1
		humanPlayer:SetCurrentEnemy(3)
		humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		
		Mine1Collapse(self)	
		dialog.dialogIndex = 8
		obj1:Activate(false)
		--self:Print("3")
	end
	
	if obj1:IsAchieved() and objState == 2 then
		objState = 3
		enemyPlayer:SetAttackable(true)
		humanPlayer:SetCurrentEnemy(1)
		humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		local nextObjective = self:GetObjective(2)
		nextObjective:Activate(true)
		
		Mine1Collapse(self)	
		dialog.dialogIndex = 8
		obj1:Activate(false)
		state = levelState.state2 -- moves to state 2
		self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_02_01)
		self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_02_03)
	end
	
	if obj2:IsAchieved() and objState == 0 then
		objState = 2
		humanPlayer:SetCurrentEnemy(2)
		humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		
		Mine2Collapse(self)
		prevDialog = dialog.dialogIndex
		dialog.dialogIndex = 96
		--self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_08, StoryChar.ADVISOR,"story_hu_level_02_ingame_08")
		dialog.repeatStart = false
		obj2:Activate(false)
	end
	
	if obj2:IsAchieved() and objState == 1 then
		objState = 3
		Mine2Collapse(self)
		prevDialog = dialog.dialogIndex
		dialog.dialogIndex = 96
		--self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_08, StoryChar.ADVISOR,"story_hu_level_02_ingame_08")
		dialog.repeatStart = false
		obj2:Activate(false)
		enemyPlayer:SetAttackable(true)
		humanPlayer:SetCurrentEnemy(1)
		humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		--self:Print("1")
		local nextObjective = self:GetObjective(2)
		nextObjective:Activate(true)
		state = levelState.state2 -- moves to state 2
		self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_02_01)
		self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_02_03)
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		ZombieAttack(self)
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,5,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		--aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		--UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 990
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1900
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 533
			building.buildInterval = 900
		end
	end
	if state == levelState.state2 then
		local obj = self:GetObjective(2)	
		if obj:IsAchieved() then
			obj:Activate(false)
			dialog.dialogIndex = 20
			state = levelState.state3
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	RepeatDialog(self,dialog,humanPlayer)
	if not self:IsStoryDialogActive() and current >= dialog.startDialog + 30 then
		if dialog.dialogIndex == 0 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_01, StoryChar.DWARFHERO, "story_hu_level_02_ingame_01")
			dialog.dialogIndex = 1
			self:DisableInput()
			AiStop(self,upgrade,building,eState)
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_02, StoryChar.ADVISOR,"story_hu_level_02_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_03, StoryChar.ADVISOR,"story_hu_level_02_ingame_03")
			local mineElevator1 = VisionGame.GetEntity(elevator1Name)
			local position = mineElevator1:GetPosition()
			self:MoveCameraTo( position )
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_04, StoryChar.ADVISOR,"story_hu_level_02_ingame_04")
			local mineElevator2 = VisionGame.GetEntity(elevator2Name)
			local position = mineElevator2:GetPosition()
			self:MoveCameraTo( position )
		dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_05, StoryChar.ADVISOR,"story_hu_level_02_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_06, StoryChar.ADVISOR,"story_hu_level_02_ingame_06")
			self:MoveCameraTo( vector3(40,280,0) )
			if tutorial then
				dialog.dialogIndex = 5.1
			else
				dialog.dialogIndex = 6
			end
		elseif dialog.dialogIndex == 5.1 then
			ShowDialog(self,LocID.LOC_TUTORIAL_TARGET_SELECTION_01, StoryChar.ADVISOR,"loc_tutorial_target_selection_01",LocID.LOC_XBOX_TUTORIAL_TS_01,"loc_xbox_tutorial_ts_01",LocID.LOC_PS3_TUTORIAL_TS_01,"loc_ps3_tutorial_ts_01")
			dialog.dialogIndex = 5.2
		elseif dialog.dialogIndex == 5.2 then
			ShowDialog(self,LocID.LOC_TUTORIAL_TARGET_SELECTION_02, StoryChar.ADVISOR,"loc_tutorial_target_selection_02",LocID.LOC_XBOX_TUTORIAL_TS_02,"loc_xbox_tutorial_ts_02",LocID.LOC_PS3_TUTORIAL_TS_02,"loc_ps3_tutorial_ts_02")
			dialog.dialogIndex = 5.3
		elseif dialog.dialogIndex == 5.3 then
			ShowDialog(self,LocID.LOC_TUTORIAL_TARGET_SELECTION_03, StoryChar.ADVISOR,"loc_tutorial_target_selection_03",LocID.LOC_XBOX_TUTORIAL_TS_03,"loc_xbox_tutorial_ts_03",LocID.LOC_PS3_TUTORIAL_TS_03,"loc_ps3_tutorial_ts_03")
			dialog.dialogIndex = 5.4
		elseif dialog.dialogIndex == 5.4 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_RALLY_01, StoryChar.ADVISOR,"loc_tutorial_rally_01")
			dialog.dialogIndex = 5.5
		elseif dialog.dialogIndex == 5.5 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_RALLY_02, StoryChar.ADVISOR,"loc_tutorial_rally_02")
			dialog.dialogIndex = 5.6
		elseif dialog.dialogIndex == 5.6 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_RALLY_03, StoryChar.ADVISOR,"loc_tutorial_rally_03")
			dialog.dialogIndex = 5.7
		elseif dialog.dialogIndex == 5.7 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_RALLY_04, StoryChar.ADVISOR,"loc_tutorial_rally_04")
			dialog.dialogIndex = 5.8
		elseif dialog.dialogIndex == 5.8 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_RALLY_05, StoryChar.ADVISOR,"loc_tutorial_rally_05")
			dialog.dialogIndex = 5.9
		elseif dialog.dialogIndex == 5.9 then
			ShowDialog(self,LocID.LOC_TUTORIAL_RALLY_06, StoryChar.ADVISOR,"loc_tutorial_rally_06",LocID.LOC_XBOX_TUTORIAL_RALLY_06,"loc_xbox_tutorial_rally_06",LocID.LOC_PS3_TUTORIAL_RALLY_06,"loc_ps3_tutorial_rally_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_HIGH_GROUND_01, StoryChar.ADVISOR,"loc_tutorial_high_ground_01")
			self:MoveCameraTo( vector3(0,0,0))
			dialog.dialogIndex = 6.1
		elseif dialog.dialogIndex == 6.1 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_HIGH_GROUND_02, StoryChar.ADVISOR,"loc_tutorial_high_ground_02")
			dialog.dialogIndex = 6.2
		elseif dialog.dialogIndex == 6.2 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_HIGH_GROUND_03, StoryChar.ADVISOR,"loc_tutorial_high_ground_03")
			dialog.dialogIndex = 6.3
		elseif dialog.dialogIndex == 6.3 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_HIGH_GROUND_04, StoryChar.ADVISOR,"loc_tutorial_high_ground_04")
			dialog.dialogIndex = 6.4
		elseif dialog.dialogIndex == 6.4 then
			self:EnableInput()
			dialog.dialogIndex = 7
			dialog.dialogEnd = true
			scriptDelay = 15
			AiStart(self,upgrade,building,eState)
			zombieTimer = GameApp.GetServerFrameCount()
		end
		
		if dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_07, StoryChar.ADVISOR,"story_hu_level_02_ingame_07")
			dialog.dialogIndex = 8.1
		elseif dialog.dialogIndex == 8.1 then -- upgrade tutorial
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_17, StoryChar.ADVISOR,"story_hu_level_02_ingame_17")
			if tutorial then self:SetObjectiveText(2, 1, LocID.LOC_OBJ_LEVEL_02_02) end
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_18, StoryChar.ADVISOR,"story_hu_level_02_ingame_18")
			if tutorial then
				dialog.dialogIndex = 10
			else
				dialog.dialogIndex = 16
			end
		elseif dialog.dialogIndex == 10 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_02_INGAME_19, StoryChar.ADVISOR,"story_hu_level_02_ingame_19",LocID.STORY_XBOX_HU_LEVEL_02_INGAME_19,"story_xbox_hu_level_02_ingame_19",LocID.STORY_PS3_HU_LEVEL_02_INGAME_19,"story_ps3_hu_level_02_ingame_19")
			GameApp.DisableEcoMenu(false)
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 11
		
		elseif dialog.dialogIndex == 11.1 then	--EconomyMenuActivated
			ShowDialog(self,LocID.STORY_HU_LEVEL_02_INGAME_20, StoryChar.ADVISOR,"story_hu_level_02_ingame_20",LocID.STORY_XBOX_HU_LEVEL_02_INGAME_20,"story_xbox_hu_level_02_ingame_20",LocID.STORY_PS3_HU_LEVEL_02_INGAME_20,"story_ps3_hu_level_02_ingame_20")
			dialog.repeatStart = false
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_02_INGAME_21, StoryChar.ADVISOR,"story_hu_level_02_ingame_21",LocID.STORY_XBOX_HU_LEVEL_02_INGAME_21,"story_xbox_hu_level_02_ingame_21",LocID.STORY_PS3_HU_LEVEL_02_INGAME_21,"story_ps3_hu_level_02_ingame_21")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 13
			
		elseif dialog.dialogIndex == 14 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_23, StoryChar.ADVISOR,"story_hu_level_02_ingame_23")
			dialog.repeatStart = false
			dialog.dialogIndex = 15
		elseif dialog.dialogIndex == 15 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_24, StoryChar.ADVISOR,"story_hu_level_02_ingame_24")
			dialog.repeatStart = false
			dialog.dialogIndex = 16
		end
		
		if humanPlayer:HasEcoUpgrade(UpgradeType.CHEAPER_TOWERS) and dialog.dialogIndex == 13 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_22, StoryChar.ADVISOR,"story_hu_level_02_ingame_22")
			if tutorial then self:SetObjectiveText(2, 2, LocID.LOC_OBJ_LEVEL_02_02) end
			dialog.repeatStart = false
			dialog.dialogIndex = 14
		end
		
		if dialog.dialogIndex == 20 then 	-- victory text
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.startDialog = GameApp.GetServerFrameCount()
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_09, StoryChar.DWARFHERO,"story_hu_level_02_ingame_09")
			self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_02_03)
			dialog.dialogIndex = 21
			humanPlayer:SetInvulnerable (true)
			enemyPlayer:SetInvulnerable (true)
		elseif dialog.dialogIndex == 21 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_10, StoryChar.DWARFHERO,"story_hu_level_02_ingame_10")
			dialog.dialogIndex = 22
		elseif dialog.dialogIndex == 22 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_11, StoryChar.ADVISOR,"story_hu_level_02_ingame_11")
			dialog.dialogIndex = 23
		elseif dialog.dialogIndex == 23 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_12, StoryChar.DWARFHERO,"story_hu_level_02_ingame_12")
			dialog.dialogIndex = 24
		elseif dialog.dialogIndex == 24 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_13, StoryChar.ADVISOR,"story_hu_level_02_ingame_13")
			dialog.dialogIndex = 25
		elseif dialog.dialogIndex == 25 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_14, StoryChar.DWARFHERO,"story_hu_level_02_ingame_14")
			dialog.dialogIndex = 26
		elseif dialog.dialogIndex == 26 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_15, StoryChar.DWARFHERO,"story_hu_level_02_ingame_15")
			dialog.dialogIndex = 27
		elseif dialog.dialogIndex == 27 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_16, StoryChar.ADVISOR,"story_hu_level_02_ingame_16")
			dialog.dialogIndex = 28
		elseif dialog.dialogIndex == 28 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 29
			
		elseif dialog.dialogIndex == 96 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_02_INGAME_08, StoryChar.ADVISOR,"story_hu_level_02_ingame_08")
			dialog.dialogIndex = prevDialog
		end	
	end
end

function ZombieAttack(self)
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)	
	local current = GameApp.GetServerFrameCount()
	--self:Print(current)
	--self:Print(zombieTimer)
	if current >= zombieTimer + 770 and state == levelState.state1 then
		if obj1:IsActive() then
			local player2 = GameApp.GetPlayer(2)
			player2:SendUnit(UnitType.DWARF)
		end
		if obj2:IsActive() then
			local player3 = GameApp.GetPlayer(3)
			player3:SendUnit(UnitType.DWARF)
		end
		zombieTimer = GameApp.GetServerFrameCount()
	end
end

function Mine1Collapse(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsActive() then
		local mineElevator1 = VisionGame.GetEntity(elevator1Name)
		mineElevator1:SetModelFile(animatedMineElevatorModelName)			
		mineElevator1:StartSkeletalAnimation(mineElevatorAnimationName)
		local elevatorPosition = mineElevator1:GetPosition()			
		VisionGame.CreateParticleEffect( crashParticleEffectName, elevatorPosition,  vector3(0,0,0) )
		
		local mineElevator1Fire =  VisionGame.GetEffect(elevator1FireName)
		--mineElevator1Fire:SetFinished(true)			
		mineElevator1Fire:Remove()
		local mineElevator1Light = VisionGame.GetObject(elevator1LightName)
		mineElevator1Light:Remove()
	end
end

function Mine2Collapse(self)
	local obj2 = self:GetObjective(1)
	if obj2:IsActive() then
		local mineElevator2 = VisionGame.GetEntity(elevator2Name)
		mineElevator2:SetModelFile(animatedMineElevator2ModelName)			
		mineElevator2:StartSkeletalAnimation(mineElevator2AnimationName)
		local elevator2Position = mineElevator2:GetPosition()			
		VisionGame.CreateParticleEffect( crashParticleEffectName, elevator2Position,  vector3(0,0,0) )
		
		local mineElevator2Fire =  VisionGame.GetEffect(elevator2FireName)
		--mineElevator2Fire:SetFinished(true)
		mineElevator2Fire:Remove()
		local mineElevator2Light = VisionGame.GetObject(elevator2LightName)
		mineElevator2Light:Remove()
	end
end

function EconomyMenuActivated(self)
	if dialog.dialogIndex == 11 then
		dialog.dialogIndex = 11.1
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 6 then
		dialog.dialogIndex = 6
		self:HideDialog()
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end