-- Mission 3: Fox den
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0

local scriptTimer = 0 
local scriptDelay = 5
local skeletonFox = false
local towerAtSpot = false
local counter = 0
local disableSettings = true
local spellCasted = false
local tutorial = false


function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	waves = {2,3,4,7,8,9,10}
	towerTypes = {1,1,5}
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	tutorial = GameApp.GetStartTutorialMode()
	
	self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	--self:DisableUnitType(UnitType.DWARF)
	self:DisableUnitType(UnitType.WIZARD) --debug
	self:DisableUnitType(UnitType.WIZARD_HERO)
	self:DisableUnitType(UnitType.GRIFFONRIDER_HERO)
	self:DisableUnitType(UnitType.ELVENARCHER_HERO)
	self:DisableUnitType(UnitType.THIEF_HERO)
	self:DisableUnitType(UnitType.CLERIC_HERO)
	self:DisableUnitType(UnitType.WARRIOR_HERO)
	self:DisableUnitType(UnitType.GUARDSMAN_HERO)
	self:DisableUnitType(UnitType.DWARF_HERO)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	
	self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	if tutorial then
		self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_03_02)
	else
		self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_03_03)
	end
	self:UnlockSpell(SpellType.REPAIRHUM)
	self:UnlockUnit(UnitType.DWARF)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_FOXWALDE_CASTLE_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_FOXWALDE_CASTLE_NAME)
    GameApp.DisableXPSystem(true) 
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if current < 30 and disableSettings then
		if tutorial then
			humanPlayer:SetCurrentHP(0.8)
		end
		humanPlayer:SetMaxTowerUpgrade(0)
		enemyPlayer:DisableDie(true)
		disableSettings = false
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		if enemyPlayer:GetCurrentHP() > 0 then
			aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
			aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
			EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
			--aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
			SendHero(self,enemyPlayer,eState,heroes,current)
			RepairTower(self,enemyPlayer,current)
			--SellUselessTowers(self,enemyPlayer,building,current)
		end
		CheckAiMode(self,humanPlayer,enemyPlayer,5,eState,current)
		HpDialog(self)
		--UpgradeTowers(self,enemyPlayer,building,eState,current)
		
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
			building.upgradeInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
			building.upgradeInterval = 500
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	--if obj1:IsAchieved() and dialog.dialogIndex == 13 then			-- win conditon
		--dialog.dialogIndex = 14
	--end

	if dialog.dialogIndex <= 29 and enemyPlayer:GetCurrentHP() <= 0.1 then
		if tutorial then 
			self:SetObjectiveText(2, 2, LocID.LOC_OBJ_LEVEL_03_03)
			self:SetObjectiveText(3, 1, LocID.LOC_OBJ_LEVEL_03_04)
		else 
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_03_03)
			self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_03_04)
		end
		dialog.dialogIndex = 30
	end

	if dialog.dialogIndex < 36 and skeletonFox then
		if not enemyPlayer:HasUnit(UnitType.FOXWALDE) then
			--self:Print("meghalt a foxwalde")
			counter = counter + 1
			if counter > 10 then
				dialog.dialogIndex = 36
				enemyPlayer:SetCurrentHP(0)
			end
		end
	end
	
	if dialog.dialogIndex == 15 then
		actualSpell = self:GetSelectedSpell()
		--self:Print(tostring(actualSpell))
		if actualSpell == 3 then
			dialog.dialogIndex = 16
		end
	end
	
	if towerAtSpot and dialog.dialogIndex == 19 then
		dialog.dialogIndex = 20
	end
	
	if dialog.dialogIndex == 35 then
		local unitSize = enemyPlayer:GetGroundUnitsSize()
		for i = 0,unitSize-1 do
			local groundUnit = enemyPlayer:GetGroundUnitAt(i)
			if groundUnit ~= nil then
				local type = groundUnit:GetUnitType()
				if type == 41 then
					groundUnit:SetCurrentHP(2700)
					dialog.dialogIndex = 35.1
				end
			end
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	RepeatDialog(self,dialog,humanPlayer)
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_01, StoryChar.ADVISOR,"story_hu_level_03_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_02, StoryChar.ADVISOR,"story_hu_level_03_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_03, StoryChar.ADVISOR,"story_hu_level_03_ingame_03")
			self:MoveCameraTo(vector3(-60,0,0))
			if tutorial then
				dialog.dialogIndex = 3
			else
				dialog.dialogIndex = 23
				self:EnableInput()
				DisableMenus("none")
				scriptDelay = 15
				AiStart(self,upgrade,building,eState)
				attack.attackTimer = GameApp.GetServerFrameCount()
				dialog.dialogEnd = true
			end
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_04, StoryChar.ADVISOR,"story_hu_level_03_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_05, StoryChar.ADVISOR,"story_hu_level_03_ingame_05")
			self:MoveCameraTo(vector3(0,0,0))
			GameApp.SetBlink(true, GuiItemType.EMPTYGRID, 0, vector3(0,0,0))
			if tutorial then self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_03_01) end
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_06, StoryChar.ADVISOR,"story_hu_level_03_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_07, StoryChar.ADVISOR,"story_hu_level_03_ingame_07")
			dialog.dialogIndex = 7
			GameApp.SetBlink(false, GuiItemType.EMPTYGRID, 0, vector3(0,0,0))
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_08, StoryChar.ADVISOR,"story_hu_level_03_ingame_08")
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_09, StoryChar.ADVISOR,"story_hu_level_03_ingame_09")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_10, StoryChar.ADVISOR,"story_hu_level_03_ingame_10")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_11, StoryChar.ADVISOR,"story_hu_level_03_ingame_11")
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_03_INGAME_12, StoryChar.ADVISOR,"story_hu_level_03_ingame_12",LocID.STORY_XBOX_HU_LEVEL_03_INGAME_12,"story_xbox_hu_level_03_ingame_12",LocID.STORY_PS3_HU_LEVEL_03_INGAME_12,"story_ps3_hu_level_03_ingame_12")
			dialog.dialogIndex = 12
			DisableMenus("spell")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			attack.attackTimer = GameApp.GetServerFrameCount()
		elseif dialog.dialogIndex == 12 then
			self:EnableInput()
			scriptDelay = 15
			dialog.dialogIndex = 13
			
		elseif dialog.dialogIndex == 14 then -- spell menu elohozasa
			ShowDialog(self,LocID.STORY_HU_LEVEL_03_INGAME_13, StoryChar.ADVISOR,"story_hu_level_03_ingame_13",LocID.STORY_XBOX_HU_LEVEL_03_INGAME_13,"story_xbox_hu_level_03_ingame_13",LocID.STORY_PS3_HU_LEVEL_03_INGAME_13,"story_ps3_hu_level_03_ingame_13")
			GameApp.SetBlink(true, GuiItemType.SPELL, SpellType.REPAIRHUM, vector3(0,0,0))
			dialog.dialogIndex = 15
			
		elseif dialog.dialogIndex == 16 then -- repair spell kivalasztva
			ShowDialog(self,LocID.STORY_HU_LEVEL_03_INGAME_14, StoryChar.ADVISOR,"story_hu_level_03_ingame_14",LocID.STORY_XBOX_HU_LEVEL_03_INGAME_14,"story_xbox_hu_level_03_ingame_14",LocID.STORY_PS3_HU_LEVEL_03_INGAME_14,"story_ps3_hu_level_03_ingame_14")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 17
			
		elseif dialog.dialogIndex == 18 then -- spell castolva
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_16, StoryChar.ADVISOR,"story_hu_level_03_ingame_16")
			GameApp.SetBlink(false, GuiItemType.SPELL, SpellType.REPAIRHUM, vector3(0,0,0))
			dialog.repeatStart = false
			DisableMenus("none")
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_03_02)
			dialog.dialogIndex = 19
			
		elseif dialog.dialogIndex == 20 then -- ha tornyot epitett a resource spotra
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_15, StoryChar.ADVISOR,"story_hu_level_03_ingame_15")
			self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_03_01)
			self:SetObjectiveText(2, 1, LocID.LOC_OBJ_LEVEL_03_03)
			dialog.dialogIndex = 21
			GameApp.SetBlink(true, GuiItemType.RESOURCE, 0, vector3(0,0,0))
		elseif dialog.dialogIndex == 21 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_17, StoryChar.ADVISOR,"story_hu_level_03_ingame_17")
			dialog.dialogIndex = 22
		elseif dialog.dialogIndex == 22 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_18, StoryChar.ADVISOR,"story_hu_level_03_ingame_18")
			GameApp.SetBlink(false, GuiItemType.RESOURCE, 0, vector3(0,0,0))
			dialog.dialogIndex = 22.01
		elseif dialog.dialogIndex == 22.01 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SELL_TOWER_01, StoryChar.ADVISOR,"loc_tutorial_sell_tower_01",LocID.LOC_XBOX_TUTORIAL_SELL_TOWER_01,"loc_xbox_tutorial_sell_tower_01",LocID.LOC_PS3_TUTORIAL_SELL_TOWER_01,"loc_ps3_tutorial_sell_tower_01")
			dialog.dialogIndex = 22.02
		elseif dialog.dialogIndex == 22.02 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SELL_TOWER_02, StoryChar.ADVISOR,"loc_tutorial_sell_tower_02",LocID.LOC_XBOX_TUTORIAL_SELL_TOWER_02,"loc_xbox_tutorial_sell_tower_02",LocID.LOC_PS3_TUTORIAL_SELL_TOWER_02,"loc_ps3_tutorial_sell_tower_02")
			dialog.dialogIndex = 22.03
		elseif dialog.dialogIndex == 22.03 then
			ShowDialog(self,LocID.LOC_TUTORIAL_SELL_TOWER_03, StoryChar.ADVISOR,"loc_tutorial_sell_tower_03",LocID.LOC_XBOX_TUTORIAL_SELL_TOWER_03,"loc_xbox_tutorial_sell_tower_03",LocID.LOC_PS3_TUTORIAL_SELL_TOWER_03,"loc_ps3_tutorial_sell_tower_03")
			dialog.dialogIndex = 22.1
		elseif dialog.dialogIndex == 22.1 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_UNLOCK_UNIT_01, StoryChar.ADVISOR,"loc_tutorial_unlock_unit_01")
			dialog.dialogIndex = 22.2
		elseif dialog.dialogIndex == 22.2 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_UNLOCK_UNIT_02, StoryChar.ADVISOR,"loc_tutorial_unlock_unit_02")
			dialog.dialogIndex = 22.3
		elseif dialog.dialogIndex == 22.3 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_UNLOCK_UNIT_03, StoryChar.ADVISOR,"loc_tutorial_unlock_unit_03")
			dialog.dialogIndex = 22.4
		elseif dialog.dialogIndex == 22.4 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_UNLOCK_UNIT_04, StoryChar.ADVISOR,"loc_tutorial_unlock_unit_04")
			dialog.dialogIndex = 22.5
		elseif dialog.dialogIndex == 22.5 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_UNLOCK_UNIT_05, StoryChar.ADVISOR,"loc_tutorial_unlock_unit_05")
			dialog.dialogIndex = 22.6
		elseif dialog.dialogIndex == 22.6 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_UNLOCK_UNIT_06, StoryChar.ADVISOR,"loc_tutorial_unlock_unit_06")
			dialog.dialogIndex = 23
			
		elseif dialog.dialogIndex == 30 then --victory text
			AiStop(self,upgrade,building,eState)
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_23, StoryChar.SKELETONHERO,"story_hu_level_03_ingame_23")
			--humanPlayer:SetInvulnerable (true)
			enemyPlayer:SetInvulnerable (true)
			dialog.dialogIndex = 31
		elseif dialog.dialogIndex == 31 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_24, StoryChar.ADVISOR,"story_hu_level_03_ingame_24")
			dialog.dialogIndex = 32
		elseif dialog.dialogIndex == 32 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_25, StoryChar.SKELETONHERO,"story_hu_level_03_ingame_25")
			if tutorial then
				dialog.dialogIndex = 32.1
			else 
				dialog.dialogIndex = 33
			end
		elseif dialog.dialogIndex == 32.1 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_BOUNTY_01, StoryChar.ADVISOR,"loc_tutorial_bounty_01")
			dialog.dialogIndex = 32.2
		elseif dialog.dialogIndex == 32.2 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_BOUNTY_02, StoryChar.ADVISOR,"loc_tutorial_bounty_02")
			dialog.dialogIndex = 32.3
		elseif dialog.dialogIndex == 32.3 then
			self:DisplayDialog(LocID.LOC_TUTORIAL_BOUNTY_05, StoryChar.ADVISOR,"loc_tutorial_bounty_05")
			dialog.dialogIndex = 32.6
		elseif dialog.dialogIndex == 32.6 then
			ShowDialog(self,LocID.LOC_TUTORIAL_BOUNTY_06, StoryChar.ADVISOR,"loc_tutorial_bounty_06",LocID.LOC_XBOX_TUTORIAL_BOUNTY_06,"loc_xbox_tutorial_bounty_06",LocID.LOC_PS3_TUTORIAL_BOUNTY_06,"loc_ps3_tutorial_bounty_06")
			dialog.dialogIndex = 33
		elseif dialog.dialogIndex == 33 then
			enemyPlayer:SendUnit(UnitType.FOXWALDE,false)
			eState.dead = true
			enemyPlayer:SetAttackable(false)
			enemyPlayer:SetCurrentHP(0)
			skeletonFox = true
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_26, StoryChar.ADVISOR,"story_hu_level_03_ingame_26")
			dialog.dialogIndex = 34
		elseif dialog.dialogIndex == 34 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_27, StoryChar.DWARFHERO,"story_hu_level_03_ingame_27")
			dialog.dialogIndex = 35
			
			
		elseif dialog.dialogIndex == 36 then --victory
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_28, StoryChar.DWARFHERO,"story_hu_level_03_ingame_28")
			self:DisableInput()
			humanPlayer:StopAllUnit()
			if tutorial then 
				self:SetObjectiveText(3, 2, LocID.LOC_OBJ_LEVEL_03_04)
			else
				self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_03_04)
			end
			dialog.dialogIndex = 37
		elseif dialog.dialogIndex == 37 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_29, StoryChar.ADVISOR,"story_hu_level_03_ingame_29")
			dialog.dialogIndex = 38
		elseif dialog.dialogIndex == 38 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_30, StoryChar.ADVISOR,"story_hu_level_03_ingame_30")
			dialog.dialogIndex = 39
		elseif dialog.dialogIndex == 39 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_31, StoryChar.ADVISOR,"story_hu_level_03_ingame_31")
			dialog.dialogIndex = 40
		elseif dialog.dialogIndex == 40 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_32, StoryChar.DWARFHERO,"story_hu_level_03_ingame_32")
			dialog.dialogIndex = 41
		elseif dialog.dialogIndex == 41 then
			dialog.dialogIndex = 42
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
		end
	end
end

function HpDialog(self)
	if not self:IsStoryDialogActive() and humanPlayer:GetCurrentHP() <= 0.75 and dialog.dialogHumanHp == 0 then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_22, StoryChar.ADVISOR,"story_hu_level_03_ingame_22")
		dialog.dialogHumanHp = 1
	end
	if not self:IsStoryDialogActive() and humanPlayer:GetCurrentHP() <= 0.25 and dialog.dialogHumanHp == 1 then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_20, StoryChar.ADVISOR,"story_hu_level_03_ingame_20")
		dialog.dialogHumanHp = 2
	end
	if not self:IsStoryDialogActive() and enemyPlayer:GetCurrentHP() <= 0.75 and dialog.dialogEnemyHp == 0 then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_19, StoryChar.ADVISOR,"story_hu_level_03_ingame_19")
		dialog.dialogEnemyHp = 1
	end
	if not self:IsStoryDialogActive() and enemyPlayer:GetCurrentHP() <= 0.25 and dialog.dialogEnemyHp == 1 then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_03_INGAME_21, StoryChar.ADVISOR,"story_hu_level_03_ingame_21")
		dialog.dialogEnemyHp = 2
	end
end

function SkipStoryActivated(self)
	if tutorial then
		if dialog.dialogIndex < 11 then
			dialog.dialogIndex = 11
			self:HideDialog()
			--DisableMenus("spell")
			GameApp.SetBlink(false, GuiItemType.EMPTYGRID, 0, vector3(0,0,0))
			--attack.attackTimer = GameApp.GetServerFrameCount()
		end
	else
		if dialog.dialogIndex <= 3 then
			self:HideDialog()
			dialog.dialogIndex = 23
			self:EnableInput()
			DisableMenus("none")
			scriptDelay = 15
			AiStart(self,upgrade,building,eState)
			attack.attackTimer = GameApp.GetServerFrameCount()
			dialog.dialogEnd = true
		end
	end
end

function UnitDamagedToBase(self, playerIndex, unitTypeIndex, targetPlayer)
	--self:Print("beert ehhez a playerhez: " ..playerIndex .. ",ez a player: " .. targetPlayer)
	--self:Print(unitTypeIndex)
	if targetPlayer == 1 and unitTypeIndex == 55 then
		--self:LoseGame()
		--self:Print("Bejutott foxwald!" .. unitTypeIndex)
	end
end

function SpellMenuActivated( self )
	--self:Print("spell menu activated")
	if dialog.dialogIndex == 13 then
		dialog.dialogIndex = 14
	end
end

function SpellCasted(self, playerIndex, spellTypeIndex)
	if dialog.dialogIndex < 18 and playerIndex == 0 then 
		dialog.dialogIndex = 18
	end
end

function TowerBuilt(self, playerIndex, towerInstance)
	--self:Print("ez a player epitett tornyot: " .. playerIndex)
	if playerIndex == 0 then
		local pos = towerInstance:GetPosition()
		--self:Print("torony pos x: " .. pos.x .. ". pos y: " .. pos.y)
		if pos.x == 0 and pos.y == 0 then
			towerAtSpot = true
		end
	end
end

function KeyDown(self, key)
	--self:Print(key)
	--if key == 66 then
	--end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end