-- Mission 4: Kind of Magic
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local enemy3Player = 0
local enemy4Player = 0
local towerCount = 0
local towerCountIndex = 0

local scriptTimer = 0 
local script3Timer = 0
local script4Timer = 0
local scriptDelay = 5
local disableSettings = true
local tutorial = false
local repairTower = 0
local repairCount = 0

local towerParticleEffectName = "graphic/effect/na_behemot_attack_earthquake.xml"
local beamParticleEffectName = "graphic/effect/beast_magic1_energybeam.xml"
local wizardShot = "graphic/effect/cloudtow_wizardshot.xml"
local boooom = "graphic/effect/cloudtw_boom.xml"
local towerActivated = "graphic/effect/cloudtow_wizardactivate.xml"
local damageEm = false
local damageTimer = 0 

towerEffect = {
	tower1 = nil,
	tower2 = nil,
	tower3 = nil,
	tower4 = nil,
}

runePos =
{
vector3(40,40,0),
vector3(-40,-40,0),
vector3(40,-40,0),
vector3(-40,40,0),
}

runeTower = {-1, -1, -1, -1}

runeCheck = 1
runeTimer = 99999
ableToStartTimer = true

function Init(self)
	tutorial = GameApp.GetStartTutorialMode()
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)	
	enemy3Player = GameApp.GetPlayer(2)
	enemy4Player = GameApp.GetPlayer(3)
	PlayerNumberInit(self)
	waves = {2,3,4,11,11,11,12,13,8}
	waves3 = {2,3,4,11,11,11,12,13,8}
	waves4 = {61,62}
	towerTypes = {1,1,2,5}
	towerTypes3 = {1,1,2,5}
	towerTypes4 = {21,21,22,25,27}
	CheckRace(self,enemyPlayer,eState)
	CheckRace(self,enemy3Player,eState3)
	CheckRace(self,enemy4Player,eState4)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	building.maxTowerCount = 12
	building.defensiveTowerLimit = 4
	building.switchToDefensiveTowerLimit = 4
	building3.maxTowerCount = 12
	building3.defensiveTowerLimit = 4
	building3.switchToDefensiveTowerLimit = 4
	building4.maxTowerCount = 12
	building4.defensiveTowerLimit = 4
	building4.switchToDefensiveTowerLimit = 4
	
	self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	--self:DisableUnitType(UnitType.DWARF)
	self:DisableUnitType(UnitType.WIZARD)
	self:DisableUnitType(UnitType.WIZARD_HERO)
	self:DisableUnitType(UnitType.GRIFFONRIDER_HERO)
	self:DisableUnitType(UnitType.ELVENARCHER_HERO)
	self:DisableUnitType(UnitType.THIEF_HERO)
	self:DisableUnitType(UnitType.CLERIC_HERO)
	self:DisableUnitType(UnitType.WARRIOR_HERO)
	self:DisableUnitType(UnitType.GUARDSMAN_HERO)
	self:DisableUnitType(UnitType.DWARF_HERO)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)	
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_04_01)
	self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_04_02)
	self:UnlockUnit(UnitType.HUMAN_DEBUFF_SLOW)
	self:UnlockSpell(SpellType.THUNDERBOLT)
	enemy4Player:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemy4Player:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_WIZARDS_COUNCIL_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_WIZARDS_COUNCIL_NAME)
	enemy3Player:SetDescriptionLocID(LocID.LOC_NMY_RENEGADE_WIZARDS_DESC)
	enemy3Player:SetNameLocID(LocID.LOC_NMY_RENEGADE_WIZARDS_NAME)
    GameApp.DisableXPSystem(true) 
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	UpdateFSM(self)
	if current < 30 and disableSettings then
		humanPlayer:SetMaxTowerUpgrade(0)
		disableSettings = false
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)
	local obj3 = self:GetObjective(2)
	if obj2:IsAchieved() and obj3:IsAchieved() and dialog.dialogIndex == 20 then			-- win conditon
		dialog.dialogIndex = 21
	end
	
	if obj1:IsAchieved() then   -- lose condition
		self:LoseGame()
	end
	
	if runeTower[1] == runeTower[2] and runeTower[2] == runeTower[3] and runeTower[3] == runeTower[4] and runeTower[1] ~= -1 then
		if ableToStartTimer then
			runeTimer = GameApp.GetServerFrameCount()
			self:SetTimer(0, 1800,true,LocID.LOC_TIMER_TOWERS)
			ableToStartTimer = false
		end
	end
	
	local current = GameApp.GetServerFrameCount()
	--self:Print(runeTimer)
	if current >= runeTimer + 1800 and ableToStartTimer == false then
		damageEm = true
		damageTimer = GameApp.GetServerFrameCount()
		runeTimer = GameApp.GetServerFrameCount()
		VisionGame.CreateParticleEffect( wizardShot, vector3(187,-172,167),  vector3(136,0,0) )
		VisionGame.CreateParticleEffect( wizardShot, vector3(174,181,167),  vector3(-134,0,0) )
		VisionGame.CreateParticleEffect( wizardShot, vector3(-174,-181,167),  vector3(46,0,0) )
		VisionGame.CreateParticleEffect( wizardShot, vector3(-182,174,167),  vector3(-42,0,0) )
		VisionGame.CreateParticleEffect( boooom, vector3(0,0,2),  vector3(-42,0,0) )
		self:SetTimer(0, 1800,true,LocID.LOC_TIMER_TOWERS)
	end
	
	if damageEm and current >= damageTimer + 200 then
		if runeTower[1] == 0 then
			--enemyPlayer:DamageToAllUnit(500)
			enemy3Player:DamageToAllUnit(500)
			enemy4Player:DamageToAllUnit(500)
			--self:Print("sebzunk mindenkit1")
			self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_04_02)
		elseif runeTower[1] == 1 then
			--humanPlayer:DamageToAllUnit(500)
			enemy3Player:DamageToAllUnit(500)
			enemy4Player:DamageToAllUnit(500)
			--self:Print("sebzunk mindenkit2")
		elseif runeTower[1] == 2 then
			humanPlayer:DamageToAllUnit(500)
			enemyPlayer:DamageToAllUnit(500)
			--enemy4Player:DamageToAllUnit(500)
			--self:Print("sebzunk mindenkit3")
		elseif runeTower[1] == 3 then
			humanPlayer:DamageToAllUnit(500)
			enemyPlayer:DamageToAllUnit(500)
			--enemy3Player:DamageToAllUnit(500)
			--self:Print("sebzunk mindenkit4")
		end
		damageEm = false
	end
	
	if towerCount == 1 and towerCountIndex == 0 and not self:IsStoryDialogActive() then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_20, StoryChar.ADVISOR,"story_hu_level_04_ingame_20")
		towerCountIndex = 1
	elseif towerCount == 2 and towerCountIndex == 1 and not self:IsStoryDialogActive() and not tutorial then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_21, StoryChar.ADVISOR,"story_hu_level_04_ingame_21")
		towerCountIndex = 2
	elseif towerCount == 3 and towerCountIndex == 2 and not self:IsStoryDialogActive() and not tutorial then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_22, StoryChar.ADVISOR,"story_hu_level_04_ingame_22")
		towerCountIndex = 3
	elseif towerCount == 4 and towerCountIndex == 3 and not self:IsStoryDialogActive() and not tutorial then
		self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_23, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_23")
		towerCountIndex = 4
	end
	
	if repairCount == 0 and tutorial then
		local towerSize = humanPlayer:GetTowersSize()
		if towerSize ~= nil and towerSize ~= 0 then
			local randomTower = GameApp.GetRandom(towerSize)
			local towerUnit = humanPlayer:GetTowerAt(randomTower)
			if towerUnit ~= nil then
				local maxHp = towerUnit:GetMaxHP()
				local currentHp = towerUnit:GetCurrentHP()
				if currentHp < maxHp then
					repairCount = 1
					local pos = towerUnit:GetPosition()
					self:MoveCameraTo( pos)
				end
			end
		end
	end
	
	if repairCount == 1 and not self:IsStoryDialogActive() and tutorial then
		ShowDialog(self,LocID.LOC_TUTORIAL_REPAIR_TOWER_01, StoryChar.ADVISOR,"loc_tutorial_repair_tower_01",LocID.LOC_XBOX_TUTORIAL_REPAIR_TOWER_01,"loc_xbox_tutorial_repair_tower_01",LocID.LOC_PS3_TUTORIAL_REPAIR_TOWER_01,"loc_ps3_tutorial_repair_tower_01")
		repairCount = 2
	end
	if repairCount == 2 and not self:IsStoryDialogActive() and tutorial then
		ShowDialog(self,LocID.LOC_TUTORIAL_REPAIR_TOWER_02, StoryChar.ADVISOR,"loc_tutorial_repair_tower_02",LocID.LOC_XBOX_TUTORIAL_REPAIR_TOWER_02,"loc_xbox_tutorial_repair_tower_02",LocID.LOC_PS3_TUTORIAL_REPAIR_TOWER_02,"loc_ps3_tutorial_repair_tower_02")
		repairCount = 3
	end
	if repairCount == 3 and not self:IsStoryDialogActive() and tutorial then
		ShowDialog(self,LocID.LOC_TUTORIAL_REPAIR_TOWER_03, StoryChar.ADVISOR,"loc_tutorial_repair_tower_03",LocID.LOC_XBOX_TUTORIAL_REPAIR_TOWER_03,"loc_xbox_tutorial_repair_tower_03",LocID.LOC_PS3_TUTORIAL_REPAIR_TOWER_03,"loc_ps3_tutorial_repair_tower_03")
		repairCount = 4
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	if not eState3.dead and enemy3Player:GetCurrentHP() <= 0 then
		eState3.dead = true
	end
	if not eState4.dead and enemy4Player:GetCurrentHP() <= 0 then
		eState4.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd and current >= scriptTimer + scriptDelay then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		--aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		--UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
	--	SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if not eState3.dead and dialog.dialogEnd and current >= script3Timer + scriptDelay + 2 then
		aiAttack(self,enemy3Player,eState3,attack3,unitCost,waves3,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemy3Player,10,eState3,current)
		aiTowers(self,humanPlayer,enemy3Player,building3,eState3,bh3,towerTypes3,current)
		EcoUpgradeCheck(self,enemy3Player,eState3,upgrade3,current)
		--HpDialog(self)
		--aiSpells(self,humanPlayer,enemy3Player,eState3,spells3,current)
		--UpgradeTowers(self,enemy3Player,building3,eState3,current)
		SendHero(self,enemy3Player,eState3,heroes3,current)
		RepairTower(self,enemy3Player,current)
		--SellUselessTowers(self,enemy3Player,building3,current)
		if eState3.state == eState3.balanced then
			attack3.attackInterval = 800
			building3.buildInterval = 700
		elseif eState3.state == eState3.defensive then
			attack3.attackInterval = 1800
			building3.buildInterval = 200
		elseif eState3.state == eState3.offensive then
			attack3.attackInterval = 333
			building3.buildInterval = 900
		end
		script3Timer = GameApp.GetServerFrameCount()
	end
	if not eState4.dead and dialog.dialogEnd and current >= script4Timer + scriptDelay + 4 then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemy4Player,eState4,attack4,unitCost,waves4,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemy4Player,10,eState4,current)
		aiTowers(self,humanPlayer,enemy4Player,building4,eState4,bh4,towerTypes4,current)
		EcoUpgradeCheck(self,enemy4Player,eState4,upgrade4,current)
		--HpDialog(self)
		--aiSpells(self,humanPlayer,enemy4Player,eState4,spells4,current)
		--UpgradeTowers(self,enemy4Player,building4,eState4,current)
		SendHero(self,enemy4Player,eState4,heroes4,current)
		RepairTower(self,enemy4Player,current)
		--SellUselessTowers(self,enemy4Player,building4,current)
		if eState4.state == eState4.balanced then
			attack4.attackInterval = 800
			building4.buildInterval = 700
		elseif eState4.state == eState4.defensive then
			attack4.attackInterval = 1800
			building4.buildInterval = 200
		elseif eState4.state == eState4.offensive then
			attack4.attackInterval = 333
			building4.buildInterval = 900
		end
		script4Timer = GameApp.GetServerFrameCount()
	end
end

function TowerBuilt(self, playerIndex, towerInstance)
	--self:Print("ez a player epitett tornyot: " .. playerIndex)
	local pos = towerInstance:GetPosition()
	for i = 1, 4 do
		if pos.x == runePos[i].x and pos.y == runePos[i].y then
			--self:Print("Stimmel a " .. i .. " szamu toronnyal")
			runeTower[i] = playerIndex
			towerCount = towerCount + 1
			if i == 1 then
				towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(174,181,167),  vector3(-134,0,0) )
				towerEffect[i]:SetKey("effect1")
			elseif i == 2 then
				towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(-174,-181,167),  vector3(46,0,0) )
				towerEffect[i]:SetKey("effect2")
			elseif i == 3 then
				towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(187,-172,167),  vector3(136,0,0) )
				towerEffect[i]:SetKey("effect3")
			elseif i == 4 then
				towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(-182,174,167),  vector3(-42,0,0) )
				towerEffect[i]:SetKey("effect4")
			end
		end
	end
end

function TowerDestroyed(self, playerIndex, towerIndex, pos)
	for i = 1, 4 do
		if pos.x == runePos[i].x and pos.y == runePos[i].y then
			runeTower[i] = -1
			--self:Print(i .. " szamu torony elpusztitva")
			ableToStartTimer = true
			self:SetTimer(0,0,true,-1)
			towerCount = towerCount - 1
			local eff = VisionGame.GetEffect("effect" .. i)
				if eff ~= nil then
					eff:SetFinished()
				end
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			AiStop(self,upgrade,building,eState)
			AiStop(self,upgrade3,building3,eState3)
			AiStop(self,upgrade4,building4,eState4)
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_01, StoryChar.ADVISOR,"story_hu_level_04_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_02, StoryChar.DWARFHERO,"story_hu_level_04_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_03, StoryChar.DWARFHERO,"story_hu_level_04_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_04, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_05, StoryChar.ADVISOR,"story_hu_level_04_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_06, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_07, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_07")
			self:MoveCameraTo( vector3(-480,0,0))
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_08, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_08")
			self:MoveCameraTo( vector3(0,-480,0))
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_09, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_09")
			self:MoveCameraTo( vector3(480,0,0))
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_10, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_10")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_11, StoryChar.DWARFHERO,"story_hu_level_04_ingame_11")
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_12, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_12")
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_13, StoryChar.ADVISOR,"story_hu_level_04_ingame_13")
			dialog.dialogIndex = 13
		elseif dialog.dialogIndex == 13 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_14, StoryChar.ADVISOR,"story_hu_level_04_ingame_14")
			if tutorial then
				dialog.dialogIndex = 14
			else
				dialog.dialogIndex = 18
			end
		elseif dialog.dialogIndex == 14 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_15, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_15")
			dialog.dialogIndex = 15
		elseif dialog.dialogIndex == 15 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_16, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_16")
			dialog.dialogIndex = 16
		elseif dialog.dialogIndex == 16 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_17, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_17")
			self:MoveCameraTo( vector3(0,0,0))
			dialog.dialogIndex = 17
		elseif dialog.dialogIndex == 17 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_18, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_18")
			dialog.dialogIndex = 18
		elseif dialog.dialogIndex == 18 then	
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_19, StoryChar.ADVISOR,"story_hu_level_04_ingame_19")
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then	
			AiStart(self,upgrade,building,eState)
			AiStart(self,upgrade3,building3,eState3)
			AiStart(self,upgrade4,building4,eState4)
			dialog.dialogEnd = true
			self:EnableInput()
			dialog.dialogIndex = 20
			scriptDelay = 15
			
		--victory text
		elseif dialog.dialogIndex == 21 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_24, StoryChar.DWARFHERO,"story_hu_level_04_ingame_24")
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_04_01)
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			enemy3Player:SetInvulnerable (true)
			enemy4Player:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 22
		elseif dialog.dialogIndex == 22 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_25, StoryChar.DWARFHERO,"story_hu_level_04_ingame_25")
			dialog.dialogIndex = 23
		elseif dialog.dialogIndex == 23 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_26, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_26")
			dialog.dialogIndex = 24
		elseif dialog.dialogIndex == 24 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_27, StoryChar.DWARFHERO,"story_hu_level_04_ingame_27")
			dialog.dialogIndex = 25
		elseif dialog.dialogIndex == 25 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_04_INGAME_28, StoryChar.WIZARDHERO,"story_hu_level_04_ingame_28")
			dialog.dialogIndex = 26
		elseif dialog.dialogIndex == 26 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 27
		end
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 19 then
		dialog.dialogIndex = 19
		self:HideDialog()
	end
end

function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
		
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end