-- Mission 5: Hero of the Day
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local enemy3Player = 0
local enemy4Player = 0

local scriptTimer = 0
local script3Timer = 0
local script4Timer = 0
local scriptDelay = 5
local disableSettings = true
local tutorial = false

function Init(self)
	tutorial = GameApp.GetStartTutorialMode()
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	enemy3Player = GameApp.GetPlayer(2)
	enemy4Player = GameApp.GetPlayer(3)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	CheckRace(self,enemy3Player,eState3)
	CheckRace(self,enemy4Player,eState4)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	waves = {2,3,4,14,15,16,16,16,8}
	waves3 = {2,3,4,14,15,16,16,16,8}
	waves4 = {61,62,63}
	towerTypes = {1,1,2,5}
	towerTypes3 = {1,1,2,5}
	towerTypes4 = {21,21,22,25,27}
	building.maxTowerCount = 12
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	building3.maxTowerCount = 12
	building3.defensiveTowerLimit = 5
	building3.switchToDefensiveTowerLimit = 5
	building4.maxTowerCount = 12
	building4.defensiveTowerLimit = 5
	building4.switchToDefensiveTowerLimit = 5
	
	self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	--self:DisableUnitType(UnitType.DWARF)
	--self:DisableUnitType(UnitType.WIZARD)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)	
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_05_01)
	self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_05_02)
	self:SetObjectiveText(2, 1, LocID.LOC_OBJ_LEVEL_05_03)
	self:UnlockUnit(UnitType.WIZARD)
	self:UnlockEconomy(UpgradeType.RESOURCE_BONUS)
	self:UnlockEconomy(UpgradeType.RESOURCE_REPLENISH)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_LOCAL_CLERGY_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_LOCAL_CLERGY_NAME)
	enemy3Player:SetDescriptionLocID(LocID.LOC_NMY_REBEL_CLERICS_DESC)
	enemy3Player:SetNameLocID(LocID.LOC_NMY_REBEL_CLERICS_NAME)
	enemy4Player:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemy4Player:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
end

function DeInit(self)

end

function Update(self)
	UpdateFSM(self)
	local current = GameApp.GetServerFrameCount()
	if current < 30 and disableSettings then
		humanPlayer:SetMaxTowerUpgrade(0)
		DisableMenus("unit")
		disableSettings = false
		end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)
	local obj3 = self:GetObjective(2)
	
	if dialog.dialogIndex == 20 then
		Units(self,humanPlayer,eState,1)
		if eState.temp == 10 then
			dialog.dialogIndex = 21
		end
	end
	if dialog.dialogIndex == 33 then
		local upgradeLevel = humanPlayer:GetUnitTypeUpgradeLevel(UnitType.WARRIOR)
		if upgradeLevel == 2 then
			local xp = humanPlayer:GetUnitTypeXP(UnitType.WARRIOR)
			if xp >= 50000 then
				dialog.dialogIndex = 34
			end
		end
	end

	if (obj2:IsAchieved() or obj3:IsAchieved()) and dialog.dialogIndex == 39 then
		dialog.dialogIndex = 40
	end

	if obj2:IsAchieved() and obj3:IsAchieved() and dialog.dialogIndex <= 42 then			-- win conditon
		self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_05_01)
		dialog.dialogIndex = 43
	end
	
	if obj2:IsAchieved() then
		self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_05_02)	
	end
	if obj3:IsAchieved() then
		self:SetObjectiveText(2, 2, LocID.LOC_OBJ_LEVEL_05_03)	
	end

	if obj1:IsAchieved() then
		self:LoseGame()
	end
end

function UpdateFSM(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		Objectives(self)
		DialogTiming(self)
	end
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	if not eState3.dead and enemy3Player:GetCurrentHP() <= 0 then
		eState3.dead = true
	end
	if not eState4.dead and enemy4Player:GetCurrentHP() <= 0 then
		eState4.dead = true
	end
	if not eState.dead and dialog.dialogEnd and current >= scriptTimer + scriptDelay then
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		--UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 990
			building.buildInterval = 800
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1900
			building.buildInterval = 300
		elseif eState.state == eState.offensive then
			attack.attackInterval = 566
			building.buildInterval = 900
		end
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if not eState3.dead and dialog.dialogEnd and current >= script3Timer + scriptDelay +2 then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemy3Player,eState3,attack3,unitCost,waves3,current)
		CheckAiMode(self,humanPlayer,enemy3Player,10,eState3,current)
		aiTowers(self,humanPlayer,enemy3Player,building3,eState3,bh3,towerTypes3,current)
		EcoUpgradeCheck(self,enemy3Player,eState3,upgrade3,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemy3Player,eState3,spells3,current)
		--UpgradeTowers(self,enemy3Player,building3,eState3,current)
		SendHero(self,enemy3Player,eState3,heroes3,current)
		RepairTower(self,enemy3Player,current)
		--SellUselessTowers(self,enemy3Player,building3,current)
		if eState3.state == eState.balanced then
			attack3.attackInterval = 800
			building3.buildInterval = 700
		elseif eState3.state == eState.defensive then
			attack3.attackInterval = 1800
			building3.buildInterval = 200
		elseif eState3.state == eState.offensive then
			attack3.attackInterval = 333
			building3.buildInterval = 900
		end
		script3Timer = GameApp.GetServerFrameCount()
	end
	if not eState4.dead and dialog.dialogEnd and current >= script4Timer + scriptDelay +4 then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemy4Player,eState4,attack4,unitCost,waves4,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemy4Player,10,eState4,current)
		aiTowers(self,humanPlayer,enemy4Player,building4,eState4,bh4,towerTypes4,current)
		EcoUpgradeCheck(self,enemy4Player,eState4,upgrade4,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemy4Player,eState4,spells4,current)
		--UpgradeTowers(self,enemy4Player,building4,eState4,current)
		SendHero(self,enemy4Player,eState4,heroes4,current)
		RepairTower(self,enemy4Player,current)
		--SellUselessTowers(self,enemy4Player,building4,current)
		if eState4.state == eState4.balanced then
			attack4.attackInterval = 800
			building4.buildInterval = 700
		elseif eState4.state == eState4.defensive then
			attack4.attackInterval = 1800
			building4.buildInterval = 200
		elseif eState4.state == eState4.offensive then
			attack4.attackInterval = 333
			building4.buildInterval = 900
		end
		script4Timer = GameApp.GetServerFrameCount()
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	RepeatDialog(self,dialog,humanPlayer)
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			AiStop(self,upgrade,building,eState)
			AiStop(self,upgrade3,building3,eState3)
			AiStop(self,upgrade4,building4,eState4)
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_01, StoryChar.ADVISOR,"story_hu_level_05_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_02, StoryChar.DWARFHERO,"story_hu_level_05_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_03, StoryChar.ADVISOR,"story_hu_level_05_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_04, StoryChar.CLERICHERO,"story_hu_level_05_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_05, StoryChar.CLERICHERO,"story_hu_level_05_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_06, StoryChar.WIZARDHERO,"story_hu_level_05_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_07, StoryChar.CLERICHERO,"story_hu_level_05_ingame_07")
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_08, StoryChar.CLERICHERO,"story_hu_level_05_ingame_08")
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_09, StoryChar.WIZARDHERO,"story_hu_level_05_ingame_09")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_10, StoryChar.ADVISOR,"story_hu_level_05_ingame_10")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_11, StoryChar.ADVISOR,"story_hu_level_05_ingame_11")
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_12, StoryChar.ADVISOR,"story_hu_level_05_ingame_12")
			self:MoveCameraTo( vector3(480,-360,0))
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_13, StoryChar.ADVISOR,"story_hu_level_05_ingame_13")
			self:MoveCameraTo( vector3(-280,-360,0))
			dialog.dialogIndex = 13
		elseif dialog.dialogIndex == 13 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_14, StoryChar.ADVISOR,"story_hu_level_05_ingame_14")
			dialog.dialogIndex = 14
		elseif dialog.dialogIndex == 14 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_15, StoryChar.ADVISOR,"story_hu_level_05_ingame_15")
			self:MoveCameraTo( vector3(-440,400,0))
			if tutorial then
				dialog.dialogIndex = 15
			else
				dialog.dialogIndex = 37
				AiStart(self,upgrade,building,eState)
				AiStart(self,upgrade3,building3,eState3)
				AiStart(self,upgrade4,building4,eState4)
				self:EnableInput()
				dialog.dialogEnd = true
				scriptDelay = 15
				DisableMenus("none")
			end
		elseif dialog.dialogIndex == 15 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_16, StoryChar.ADVISOR,"story_hu_level_05_ingame_16")
			dialog.dialogIndex = 16
		elseif dialog.dialogIndex == 16 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_17, StoryChar.ADVISOR,"story_hu_level_05_ingame_17")
			dialog.dialogIndex = 17
		elseif dialog.dialogIndex == 17 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_18, StoryChar.ADVISOR,"story_hu_level_05_ingame_18")
			dialog.dialogIndex = 18
		elseif dialog.dialogIndex == 18 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_19, StoryChar.ADVISOR,"story_hu_level_05_ingame_19")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then
			AiStart(self,upgrade,building,eState)
			AiStart(self,upgrade3,building3,eState3)
			AiStart(self,upgrade4,building4,eState4)
			dialog.dialogIndex = 20
			self:EnableInput()
			dialog.dialogEnd = true
			GameApp.SetBlink(true, GuiItemType.UNIT, UnitType.WARRIOR, vector3(0,0,0))
			scriptDelay = 15
			
		-- ha van 10 warrior
		elseif dialog.dialogIndex == 21 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_20, StoryChar.ADVISOR,"story_hu_level_05_ingame_20")
			GameApp.SetBlink(false, GuiItemType.UNIT, UnitType.WARRIOR, vector3(0,0,0))
			dialog.repeatStart = false
			DisableMenus("none")
			dialog.dialogIndex = 22
		elseif dialog.dialogIndex == 22 then
			ShowDialog(self,LocID.STORY_HU_LEVEL_05_INGAME_21, StoryChar.ADVISOR,"story_hu_level_05_ingame_21",LocID.STORY_XBOX_HU_LEVEL_05_INGAME_21,"story_xbox_hu_level_05_ingame_21",LocID.STORY_PS3_HU_LEVEL_05_INGAME_21,"story_ps3_hu_level_05_ingame_21")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 23
		elseif dialog.dialogIndex == 23.1 then -- unitshop megnyitasa
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_22, StoryChar.ADVISOR,"story_hu_level_05_ingame_22")
			GameApp.SetBlink(true, GuiItemType.XPBAR, UnitType.WARRIOR, vector3(0,0,0))
			dialog.repeatStart = false
			dialog.dialogIndex = 24
		elseif dialog.dialogIndex == 24 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_23, StoryChar.ADVISOR,"story_hu_level_05_ingame_23")
			dialog.dialogIndex = 25
		elseif dialog.dialogIndex == 25 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_24, StoryChar.ADVISOR,"story_hu_level_05_ingame_24")
			dialog.dialogIndex = 26
		elseif dialog.dialogIndex == 26 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_25, StoryChar.ADVISOR,"story_hu_level_05_ingame_25")
			GameApp.SetBlink(false, GuiItemType.XPBAR, UnitType.WARRIOR, vector3(0,0,0))
			GameApp.SetBlink(true, GuiItemType.LEVEL, UnitType.WARRIOR, vector3(0,0,0))
			dialog.dialogIndex = 27
		elseif dialog.dialogIndex == 27 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_26, StoryChar.ADVISOR,"story_hu_level_05_ingame_26")
			dialog.dialogIndex = 28
		elseif dialog.dialogIndex == 28 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_27, StoryChar.ADVISOR,"story_hu_level_05_ingame_27")
			dialog.dialogIndex = 29
		elseif dialog.dialogIndex == 29 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_28, StoryChar.ADVISOR,"story_hu_level_05_ingame_28")
			dialog.dialogIndex = 30
		elseif dialog.dialogIndex == 30 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_29, StoryChar.ADVISOR,"story_hu_level_05_ingame_29")
			dialog.dialogIndex = 31
		elseif dialog.dialogIndex == 31 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_30, StoryChar.ADVISOR,"story_hu_level_05_ingame_30")
			GameApp.SetBlink(false, GuiItemType.LEVEL, UnitType.WARRIOR, vector3(0,0,0))
			dialog.dialogIndex = 32
		elseif dialog.dialogIndex == 32 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_31, StoryChar.ADVISOR,"story_hu_level_05_ingame_31")
			dialog.dialogIndex = 33
			
		-- ha elerheto a warr hero
		elseif dialog.dialogIndex == 34 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_32, StoryChar.ADVISOR,"story_hu_level_05_ingame_32")
			dialog.dialogIndex = 35
		elseif dialog.dialogIndex == 35 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_33, StoryChar.WARRIORHERO,"story_hu_level_05_ingame_33")
			dialog.dialogIndex = 36
		elseif dialog.dialogIndex == 36 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_34, StoryChar.ADVISOR,"story_hu_level_05_ingame_34")
			dialog.dialogIndex = 37
		elseif dialog.dialogIndex == 37 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_35, StoryChar.DWARFHERO,"story_hu_level_05_ingame_35")
			dialog.dialogIndex = 38
		elseif dialog.dialogIndex == 38 then	
			dialog.dialogIndex = 39
		
		-- ha egy enemy elpusztult
		elseif dialog.dialogIndex == 40 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_36, StoryChar.ADVISOR,"story_hu_level_05_ingame_36")
			dialog.dialogIndex = 41
		elseif dialog.dialogIndex == 41 then	
			dialog.dialogIndex = 42
			
		--victory text
		elseif dialog.dialogIndex == 43 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_37, StoryChar.ADVISOR,"story_hu_level_05_ingame_37")
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			enemy3Player:SetInvulnerable (true)
			enemy4Player:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 44
		elseif dialog.dialogIndex == 44 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_05_INGAME_38, StoryChar.WIZARDHERO,"story_hu_level_05_ingame_38")
			dialog.dialogIndex = 45
		elseif dialog.dialogIndex == 45 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 46
		end
	end
end

function SkipStoryActivated(self)
	if tutorial then
		if dialog.dialogIndex < 18 then
			dialog.dialogIndex = 18
			self:HideDialog()
		end
	else
		if dialog.dialogIndex < 18 then
			dialog.dialogIndex = 38
			AiStart(self,upgrade,building,eState)
			AiStart(self,upgrade3,building3,eState3)
			AiStart(self,upgrade4,building4,eState4)
			self:EnableInput()
			dialog.dialogEnd = true
			scriptDelay = 15
			DisableMenus("none")
		end
	end
end

function UnitShopMenuActivated( self )
	if dialog.dialogIndex == 23 then
		dialog.dialogIndex = 23.1
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end