-- Mission 6: Ghosts of the Past
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local enemy3Player = 0
local towerCountdown = 99999
local Zagadu = false
local warningDialog = true
local target = true
local ZagaduDead = false

local scriptTimer = 0 
local scriptDelay = 5
local disableSettings = true

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	enemy3Player = GameApp.GetPlayer(2)
	PlayerNumberInit(self)
	enemy3Player:SetMinimapHPIconVisible(false)
	CheckRace(self,enemyPlayer,eState)
	waves = {5}
	towerTypes = {1,1,2,4,5}
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	spells.spellRepairInterval = 1200
	building.maxTowerCount = 10
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	
	self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	self:DisableUnitType(UnitType.WIZARD_HERO)
	--self:DisableUnitType(UnitType.DWARF)
	--self:DisableUnitType(UnitType.WIZARD)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_AIR)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_06_01)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_MINOTAURS_LAIR_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_MINOTAURS_LAIR_NAME)
	self:UnlockEconomy(UpgradeType.UNIT_POOL_UPGRADE)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if current < 30 and disableSettings then
		humanPlayer:SetMaxTowerUpgrade(0)
		disableSettings = false
	end
end

function Objectives(self)
	--local obj1 = self:GetObjective(0)
	--if obj1:IsAchieved() then			-- win conditon
		--self:WinGame(humanPlayerIndex)
	--end
	
	local current = GameApp.GetServerFrameCount()
	if current >= attack.attackTimer + attack.attackInterval + attack.random + 500 then
		if dialog.dialogIndex >= 21 and dialog.dialogIndex <= 41 then
			if target then
				enemyPlayer:SetOnlyCurrentEnemy(2)
				enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
				--enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
				target = false
			else
				enemyPlayer:SetOnlyCurrentEnemy(0)
				enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
				enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
				--enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
				target = true
			end
		else
			enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
			enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
			--enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
		end
		attack.attackTimer = GameApp.GetServerFrameCount()
		--self:Print("Jonnek!")
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	enemy3Player:SetInvulnerable (true)
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		--aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		--aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		--UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 600
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	-- start text
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			AiStop(self,upgrade,building,eState)
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_01, StoryChar.DWARFHERO,"story_hu_level_06_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_02, StoryChar.DWARFHERO,"story_hu_level_06_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_03, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_03")
			--self:MoveCameraTo(vector3(-60,0,0))
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_04, StoryChar.DWARFHERO,"story_hu_level_06_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_05, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_06, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_07, StoryChar.DWARFHERO,"story_hu_level_06_ingame_07")
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_08, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_08")
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_09, StoryChar.ADVISOR,"story_hu_level_06_ingame_09")
			self:MoveCameraTo(vector3(320,200,0))
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_10, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_10")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_11, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_11")
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_12, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_12")
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			dialog.dialogIndex = 13
		elseif dialog.dialogIndex == 13 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_13, StoryChar.DWARFHERO,"story_hu_level_06_ingame_13")
			dialog.dialogIndex = 14
		elseif dialog.dialogIndex == 14 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_14, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_14")
			dialog.dialogIndex = 15
		elseif dialog.dialogIndex == 15 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_15, StoryChar.DWARFHERO,"story_hu_level_06_ingame_15")
			dialog.dialogIndex = 16
		elseif dialog.dialogIndex == 16 then
			enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
			enemyPlayer:SendUnit(UnitType.MINOTAURUS,false)
			self:EnableInput()
			attack.attackTimer = GameApp.GetServerFrameCount()
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			scriptDelay = 10
			dialog.dialogIndex = 17
			towerCountdown = GameApp.GetServerFrameCount()

		elseif current >= towerCountdown + 1200 and dialog.dialogIndex == 17 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_16, StoryChar.ADVISOR,"story_hu_level_06_ingame_16")
			enemy3Player:SetAttackable(true)
			humanPlayer:SetOnlyCurrentEnemy(2)
			--self:Print("attacking the lighthouse")
			while not success do
				success = humanPlayer:SendUnit(UnitType.WIZARD_HERO,false)
			end
			Zagadu = true
			--humanPlayer:SetCurrentEnemy(1)
			--enemy3Player:SetAttackable(false)
			
			dialog.dialogIndex = 70
		elseif current >= towerCountdown + 1230 and dialog.dialogIndex == 70 then
			humanPlayer:SetOnlyCurrentEnemy(1)
			--self:Print("attacking the ai")
			dialog.dialogIndex = 99
			towerCountdown = 99999
			
		elseif dialog.dialogIndex == 18 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_17, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_17")
			self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_06_03)
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_18, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_18")
			dialog.dialogIndex = 20
		elseif dialog.dialogIndex == 20 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_19, StoryChar.ADVISOR,"story_hu_level_06_ingame_19")
			dialog.dialogIndex = 21
		elseif dialog.dialogIndex == 21 then
			--todo: enemy menjen a toronyba
			enemyPlayer:SetOnlyCurrentEnemy(2)
			towerCountdown = GameApp.GetServerFrameCount()
			self:SetTimer(0,5400,true,LocID.LOC_TIMER_ZAGADU)
			dialog.dialogIndex = 23
		
		elseif dialog.dialogIndex == 23 and current >= towerCountdown + 1800 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_21, StoryChar.DWARFHERO,"story_hu_level_06_ingame_21")
			dialog.dialogIndex = 24
		elseif dialog.dialogIndex == 24 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_22, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_22")
			dialog.dialogIndex = 25
			
		elseif dialog.dialogIndex == 25 and current >= towerCountdown + 3600 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_23, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_23")
			dialog.dialogIndex = 26
		elseif dialog.dialogIndex == 26 and current >= towerCountdown + 5400 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_24, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_24")
			dialog.dialogIndex = 27
			
		elseif dialog.dialogIndex == 27 then -- victory text
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_25, StoryChar.DWARFHERO,"story_hu_level_06_ingame_25")
			self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_06_03)
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_06_01)
			humanPlayer:SetInvulnerable (true)
			enemyPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 28
		elseif dialog.dialogIndex == 28 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_26, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_26")
			dialog.dialogIndex = 29
		elseif dialog.dialogIndex == 29 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_27, StoryChar.DWARFHERO,"story_hu_level_06_ingame_27")
			dialog.dialogIndex = 30
		elseif dialog.dialogIndex == 30 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_28, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_28")
			dialog.dialogIndex = 31
		elseif dialog.dialogIndex == 31 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_29, StoryChar.ADVISOR,"story_hu_level_06_ingame_29")
			dialog.dialogIndex = 32
		elseif dialog.dialogIndex == 32 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_30, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_30")
			dialog.dialogIndex = 33
		elseif dialog.dialogIndex == 33 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_31, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_31")
			dialog.dialogIndex = 34
		elseif dialog.dialogIndex == 34 then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_32, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_32")
			dialog.dialogIndex = 35
		elseif dialog.dialogIndex == 35 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 36
			
		elseif Zagadu and not humanPlayer:HasUnit(UnitType.WIZARD_HERO) and not ZagaduDead then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_33, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_33")
			dialog.dialogIndex = 38
			ZagaduDead = true
		elseif dialog.dialogIndex == 38 then
			dialog.dialogIndex = 39
			self:LoseGame()
		end
	end
end

function UnitDamagedToBase(self, playerIndex, unitTypeIndex, targetPlayer)
	--self:Print("beert ehhez a playerhez: " ..playerIndex .. ",ez a player: " .. targetPlayer)
	if playerIndex == 2 and unitTypeIndex == 15 then
		dialog.dialogIndex = 18
		Zagadu = false
		--self:Print("Bejutott zagadu!")
	end
	if playerIndex == 2 and targetPlayer == 1 and dialog.dialogIndex <= 26 then
		if warningDialog then
			self:DisplayDialog(LocID.STORY_HU_LEVEL_06_INGAME_20, StoryChar.WIZARDHERO,"story_hu_level_06_ingame_20")
			warningDialog = false
		end
		towerCountdown = GameApp.GetServerFrameCount()
		self:SetTimer(0,5400,true,LocID.LOC_TIMER_ZAGADU)
		--self:Print("Bejutott az ai!")
	end
	--dialog.dialogIndex = 99
end

function SkipStoryActivated(self)
	--self:Print(key)
		if dialog.dialogIndex < 16 then
			dialog.dialogIndex = 16
			self:HideDialog()
		end
		--for i=1,building.maxTowerCount do
			--self:Print(tostring(towerFree[i]))
		--end
		--local id = self:GetMapID()
		--self:Print(id)
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end