VisionLua.LoadScript("scene\\common_ai.lua")

Player1 = 0
Player2 = 0
Player3 = 0
Player4 = 0

local scriptTimer = 0
local script3Timer = 0
local script4Timer = 0
local scriptDelay = 5
local timeLimit = 0

local ai = {
	aiPlayer1 = false,
	aiPlayer2 = true,
	aiPlayer3 = false,
	aiPlayer4 = false,
}

local teams = {}
local Player1Enemy = 0
local Player2Enemy = 0
local Player3Enemy = 0
local Player4Enemy = 0
local map = 0
local maxTower = {3,3,7,12,12,10,9,10,11,12,12,12,10,10,7,7,8,12}

--map 16
local damageHuman = true
local damageEnemy = true
local totalHp = 0
local demonTimer = 0

--map 4
local towerParticleEffectName = "graphic/effect/na_behemot_attack_earthquake.xml"
local beamParticleEffectName = "graphic/effect/beast_magic1_energybeam.xml"
local wizardShot = "graphic/effect/cloudtow_wizardshot.xml"
local boooom = "graphic/effect/cloudtw_boom.xml"
local towerActivated = "graphic/effect/cloudtow_wizardactivate.xml"
local damageEm = false
local damageTimer = 0 
towerEffect = {
	tower1 = nil,
	tower2 = nil,
	tower3 = nil,
	tower4 = nil,
}
runePos =
{
vector3(40,40,0),
vector3(-40,-40,0),
vector3(40,-40,0),
vector3(-40,40,0),
}
runeTower = {-1, -1, -1, -1}
runeCheck = 1
runeTimer = 99999
ableToStartTimer = true

-- map 13
local meteorName = "graphic/effect/meteor_impact.xml"
local meteorDecal = "graphic/effect/meteor_impact.xml"
local meteorTimer = 0
local meteorDelay = 200
local meteorRandom = GameApp.GetRandom(300,"lvl13_meteor")
local meteorCount = 0

function Init(self)
	Player1 = GameApp.GetPlayer(0)
	Player2 = GameApp.GetPlayer(1)
	if GameApp.GetPlayerCount() >= 3 then
		Player3 = GameApp.GetPlayer(2)
		ai.aiPlayer3 = Player3:IsAI()
	end
	if GameApp.GetPlayerCount() == 4 then
		Player4 = GameApp.GetPlayer(3)
		ai.aiPlayer4 = Player4:IsAI()
		--self:Print("player4 created")
	end
	ai.aiPlayer1 = Player1:IsAI()
	ai.aiPlayer2 = Player2:IsAI()
	--self:Print(eState.playerNumb)
	--to1 = Player1:GetTowersSize()
	--to2 = Player2:GetTowersSize()
	--to3 = Player3:GetTowersSize()
	--to4 = Player4:GetTowersSize()
	--self:Print("Pl1 tower number: " .. to1 .. ". Pl2 tower: " .. to2 .. ". Pl3 tower: " .. to3 .. ". Pl4 tower: " .. to4)
	
	map = self:GetMapID()
	multiMode = GameApp.GetMultiGameplayType()
	
	PlayerNumberInit(self)
	building.maxTowerCount = maxTower[map]
	if ai.aiPlayer2 then CheckRace(self,Player2,eState) end
	if eState.playerNumb >= 3 then
		if ai.aiPlayer3 then CheckRace(self,Player3,eState3) end
		teams[3] = Player3:GetPlayerTeam()
	end
	if eState.playerNumb == 4 then
		if ai.aiPlayer4 then CheckRace(self,Player4,eState4) end
		teams[4] = Player4:GetPlayerTeam()
	end
	teams[1] = Player1:GetPlayerTeam()
	teams[2] = Player2:GetPlayerTeam()
	
	RefreshUnitCost(self,Player2,unitCost)
	
	if teams[2] ~= teams[1] then
		Player2Enemy = Player1
		Player1Enemy = Player2
	else
		if teams[2] ~= teams[3] and eState.playerNumb >= 3 then
			Player2Enemy = Player3
			Player3Enemy = Player2
		else
			if teams[2] ~= teams[4] and eState.playerNumb == 4 then
				Player2Enemy = Player4
				Player4Enemy = Player2
			end
		end
	end
	if teams[3] ~= teams[1] and eState.playerNumb >= 3 then
		Player3Enemy = Player1
		Player1Enemy = Player3
	else
		if teams[3] ~= teams[4] and eState.playerNumb == 4 then
			Player3Enemy = Player4
			Player4Enemy = Player3
		end
	end
	if teams[4] ~= teams[1] and eState.playerNumb == 4 then
		Player4Enemy = Player1
		Player1Enemy = Player4
	end
	
	if map == 16 then
		local daemon = GameApp.GetPlayer(2)
		daemon:SetMinimapHPIconVisible(false)
		daemon:SetInvulnerable (true)
		daemon:SetDescriptionLocID(LocID.STORY_UN_LEVEL_16_DAEMON_DESC)
		daemon:SetBaseIconFileName("graphic/gui/ingame/underworld/big/unit/info_human_unit_demon.dds")
		daemon:SetDisabledBaseIconFileName("graphic/gui/ingame/underworld/big/unit/info_human_unit_demon.dds")
		self:AttachEffectEntityToEntityBone( "Balrog", "headfire_bone", "", "graphic/effect/balrog_fire_head_sm.xml", "demon_fire_1" )
		self:AttachEffectEntityToEntityBone( "Balrog", "elbow_bone1", 	"", "graphic/effect/balrog_fire_elbow_sm.xml", "demon_fire_2" )
		self:AttachEffectEntityToEntityBone( "Balrog", "elbow_bone2",		"", "graphic/effect/balrog_fire_elbow_sm.xml", "demon_fire_3" )
	
		self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone1", "", "graphic/effect/balrog_base.xml" )
		self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone2", "", "graphic/effect/balrog_base.xml" )
		self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone3", "", "graphic/effect/balrog_base.xml" )
		self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone4", "", "graphic/effect/balrog_base.xml" )
		self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone5", "", "graphic/effect/balrog_base.xml" )
		self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone6", "", "graphic/effect/balrog_base.xml" )
		demonTimer = GameApp.GetServerFrameCount()
		self:SetTimer(1,1800,true,LocID.LOC_TIMER_DAEMON)
		balrog = VisionGame.GetEntity("Balrog")
	end
	timeLimit = GameApp.GetTimeLimitFrame()
	self:SetTimer(0, timeLimit,true,LocID.LOC_MENU_TIMELIMIT)
end

function DeInit(self)
end

function Update(self)
	UpdateFSM(self)
end

function Objectives(self)
	local current = GameApp.GetServerFrameCount()
	if timeLimit ~= -1 then
		local condition = GameApp.GetWinCondition()
		if condition == 0 then
			if current >= timeLimit then
				self:SetObjectiveText(0, 1, LocID.LOC_MULTI_SUDDEN_DEATH)
			end
		end
	end
	if map == 13 then
		if current >= meteorTimer + meteorDelay + meteorRandom then
			MeteorStorm(self)
			meteorCount = meteorCount + 1
			if meteorCount >= 6 then
				meteorCount = 0
				meteorTimer = GameApp.GetServerFrameCount()
				meteorRandom = GameApp.GetRandom(400,"lvl13_meteor_time")
			end
		end
	end
	if map == 16 then
		if current >= demonTimer + 1800 then
			self:SetTimer(1,1800,true,LocID.LOC_TIMER_DAEMON)
			demonTimer = GameApp.GetServerFrameCount()
			balrog:Attack()
			if damagePlayer1 then
				Player1:DamageToAllUnit(100)
				self:Print("damage to player1")
			else
				damagePlayer1 = true
			end
			if damagePlayer2 then
				Player2:DamageToAllUnit(100)
				self:Print("damage to player2")
			else
				damagePlayer2 = true
			end
		end
	end
	if map == 4 then
		if runeTower[1] == runeTower[2] and runeTower[2] == runeTower[3] and runeTower[3] == runeTower[4] and runeTower[1] ~= -1 then
			if ableToStartTimer then
				runeTimer = GameApp.GetServerFrameCount()
				self:SetTimer(1, 1800,true,LocID.LOC_TIMER_TOWERS)
				ableToStartTimer = false
			end
		end
	
		if current >= runeTimer + 1800 and ableToStartTimer == false then
			damageEm = true
			damageTimer = GameApp.GetServerFrameCount()
			runeTimer = GameApp.GetServerFrameCount()
			VisionGame.CreateParticleEffect( wizardShot, vector3(187,-172,167),  vector3(136,0,0) )
			VisionGame.CreateParticleEffect( wizardShot, vector3(174,181,167),  vector3(-134,0,0) )
			VisionGame.CreateParticleEffect( wizardShot, vector3(-174,-181,167),  vector3(46,0,0) )
			VisionGame.CreateParticleEffect( wizardShot, vector3(-182,174,167),  vector3(-42,0,0) )
			VisionGame.CreateParticleEffect( boooom, vector3(0,0,2),  vector3(-42,0,0) )
			self:SetTimer(1, 1800,true,LocID.LOC_TIMER_TOWERS)
		end
		
		if damageEm and current >= damageTimer + 200 then
			
			if runeTower[1] == 0 then
				if multiMode == 0 then
					Player2:DamageToAllUnit(500)
				end
				if eState.playerNumb >= 3 then Player3:DamageToAllUnit(500) end
				if eState.playerNumb == 4 then Player4:DamageToAllUnit(500)	end
				--self:Print("sebzunk mindenkit1")
			elseif runeTower[1] == 1 then
				if multiMode == 0 then
					Player1:DamageToAllUnit(500)
				end
				if eState.playerNumb >= 3 then Player3:DamageToAllUnit(500) end
				if eState.playerNumb == 4 then Player4:DamageToAllUnit(500) end
				--self:Print("sebzunk mindenkit2")
			elseif runeTower[1] == 2 then
				Player1:DamageToAllUnit(500)
				Player2:DamageToAllUnit(500)
				if multiMode == 0 then
					if eState.playerNumb == 4 then Player4:DamageToAllUnit(500) end
				end
				--self:Print("sebzunk mindenkit3")
			elseif runeTower[1] == 3 then
				Player1:DamageToAllUnit(500)
				Player2:DamageToAllUnit(500)
				if multiMode == 0 then
					if eState.playerNumb >= 3 then Player3:DamageToAllUnit(500) end
				end
				--self:Print("sebzunk mindenkit4")
			end
			damageEm = false
		end		
	end
end

function UpdateFSM(self)
	Objectives(self)
	--DialogTiming(self)
	if not eState.dead and Player2:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	--self:MultiLog("Player 1 AI: " .. tostring(ai.aiPlayer1) ..  ". Player 2 AI: " .. tostring(ai.aiPlayer2) .. ". Player 3 AI: " .. tostring(ai.aiPlayer3) .. ". Player 4 AI: " .. tostring(ai.aiPlayer4))
	--self:MultiLog(" current time: " .. current .. ". script activate: " ..scriptTimer)
	--self:MultiLog("Player 2 dead: " .. tostring(eState.dead) .. ". Player 3 dead: " .. tostring(eState3.dead) .. ". Player 4 dead: " .. tostring(eState4.dead))
  --self:Print("Player 2: " .. eState.aiRace .. ". Player 3: " .. eState3.aiRace .. ". Player 4: " .. eState4.aiRace)
	--pl2 = Player2:GetID()
  --pl3 = Player3:GetID()
  --pl4 = Player4:GetID()
  --self:MultiLog("Player2: " .. pl2 .. ". Player3: " .. pl3 .. ". Player4: " .. pl4)
	if not eState.dead and current >= scriptTimer + scriptDelay and ai.aiPlayer2 and map ~= 16 then -- semmit ne csinaljon a kezdo dialog vegeig
		CheckAiMode(self,Player2Enemy,Player2,15,eState,current)
		aiTowers(self,Player2Enemy,Player2,building,eState,bh,towerTypes,current)
		aiAttack(self,Player2,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		EcoUpgradeCheck(self,Player2,eState,upgrade,current)
		aiSpells(self,Player2Enemy,Player2,eState,spells,current)
		UpgradeTowers(self,Player2,building,eState,current)
		SendHero(self,Player2,eState,heroes,current)
		RepairTower(self,Player2,current)
		SellUselessTowers(self,Player2,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 500
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
		scriptTimer = GameApp.GetServerFrameCount()
	end
	
	if eState.playerNumb >= 3 then
		if not eState3.dead and Player3:GetCurrentHP() <= 0 then
			eState3.dead = true
		end
		if not eState3.dead and current >= script3Timer + scriptDelay + 2 and ai.aiPlayer3 and map ~= 16 then
			
			CheckAiMode(self,Player3Enemy,Player3,15,eState3,current)
			aiTowers(self,Player3Enemy,Player3,building3,eState3,bh3,towerTypes3,current)
			
			aiAttack(self,Player3,eState3,attack3,unitCost,waves3,current)
			EcoUpgradeCheck(self,Player3,eState3,upgrade3,current)
			aiSpells(self,Player3Enemy,Player3,eState3,spells3,current)
			UpgradeTowers(self,Player3,building3,eState3,current)
			SendHero(self,Player3,eState3,heroes3,current)
			RepairTower(self,Player3,current)
			SellUselessTowers(self,Player3,building3,current)
			if eState3.state == eState3.balanced then
				attack3.attackInterval = 800
				building3.buildInterval = 500
			elseif eState3.state == eState3.defensive then
				attack3.attackInterval = 1800
				building3.buildInterval = 200
			elseif eState3.state == eState3.offensive then
				attack3.attackInterval = 333
				building3.buildInterval = 1000
			end
			script3Timer = GameApp.GetServerFrameCount()
		end
    end
	if eState.playerNumb == 4 then	
		if not eState4.dead and Player4:GetCurrentHP() <= 0 then
			eState4.dead = true
		end
		if not eState4.dead and current >= script4Timer + scriptDelay +4 and ai.aiPlayer4 and map ~= 16 then
			CheckAiMode(self,Player4Enemy,Player4,15,eState4)
			aiTowers(self,Player4Enemy,Player4,building4,eState4,bh4,towerTypes4,current)
			
			aiAttack(self,Player4,eState4,attack4,unitCost,waves4,current)
			EcoUpgradeCheck(self,Player4,eState4,upgrade4,current)
			aiSpells(self,Player4Enemy,Player4,eState4,spells4,current)
			UpgradeTowers(self,Player4,building4,eState4,current)
			SendHero(self,Player4,eState4,heroes4,current)
			RepairTower(self,Player4,current)
			SellUselessTowers(self,Player4,building4,current)
			if eState4.state == eState4.balanced then
				attack4.attackInterval = 800
				building4.buildInterval = 500
			elseif eState4.state == eState4.defensive then
				attack4.attackInterval = 1800
				building4.buildInterval = 200
			elseif eState4.state == eState4.offensive then
				attack4.attackInterval = 333
				building4.buildInterval = 1000
			end
			script4Timer = GameApp.GetServerFrameCount()
		end
	end
end

function UnitDamagedToBase(self, playerIndex, unitTypeIndex, targetPlayer, hp)
	--self:Print("beert ehhez a playerhez: " ..playerIndex .. ",ez a player: " .. targetPlayer)
	if playerIndex == 1 and ai.aiPlayer2 then
		Player2Enemy = GameApp.GetPlayer(targetPlayer)
	elseif playerIndex == 2 and ai.aiPlayer3 then
		Player3Enemy = GameApp.GetPlayer(targetPlayer)
	elseif playerIndex == 3 and ai.aiPlayer4 then
		Player4Enemy = GameApp.GetPlayer(targetPlayer)
	end
	
	if map == 16 then
		if playerIndex == 2 and targetPlayer == 0 then
			damagePlayer1 = false
		elseif playerIndex == 2 and targetPlayer == 1 then
			damagePlayer2 = false
		end
	end
end

function TowerBuilt(self, playerIndex, towerInstance)
	if map == 4 then
		--self:Print("ez a player epitett tornyot: " .. playerIndex)
		local pos = towerInstance:GetPosition()
		for i = 1, 4 do
			if pos.x == runePos[i].x and pos.y == runePos[i].y then
				--self:Print("Stimmel a " .. i .. " szamu toronnyal")
				runeTower[i] = playerIndex
				if i == 1 then
					towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(174,181,167),  vector3(-134,0,0) )
					towerEffect[i]:SetKey("effect1")
				elseif i == 2 then
					towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(-174,-181,167),  vector3(46,0,0) )
					towerEffect[i]:SetKey("effect2")
				elseif i == 3 then
					towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(187,-172,167),  vector3(136,0,0) )
					towerEffect[i]:SetKey("effect3")
				elseif i == 4 then
					towerEffect[i] = VisionGame.CreateParticleEffect( towerActivated, vector3(-182,174,167),  vector3(-42,0,0) )
					towerEffect[i]:SetKey("effect4")
				end
			end
		end
	end
end

function TowerDestroyed(self, playerIndex, towerIndex, pos)
	if map == 4 then
		for i = 1, 4 do
			if pos.x == runePos[i].x and pos.y == runePos[i].y then
				runeTower[i] = -1
				--self:Print(i .. " szamu torony elpusztitva")
				ableToStartTimer = true
				self:SetTimer(1,0,true,-1)
				local eff = VisionGame.GetEffect("effect" .. i)
				if eff ~= nil then
					eff:SetFinished()
				end
			end
		end
	end
end
    
function MeteorStorm(self)
	local x = GameApp.GetRandom(16,"meteor_x_coord")
	local y = GameApp.GetRandom(24,"meteor_y_coord")
	local pos = vector3(0,0,0)
	pos.x = (x*40) - 240
	pos.y = (y*40) - 520
	--self:Print(pos.x)
	--self:Print(pos.y)
	VisionGame.CreateParticleEffect( meteorName, pos,  vector3(0,-90,0) )
	GameApp.RadiusDamage(100, 60, pos)
end

function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
        --self:Print("Player 2 AI: " .. tostring(ai.aiPlayer2) .. ". Player 3 AI: " .. tostring(ai.aiPlayer3) .. ". Player 4 AI: " .. tostring(ai.aiPlayer4))
        --self:Print("Player 2: " .. tostring(eState.dead) .. ". Player 3: " .. tostring(eState3.dead) .. ". Player 4: " .. tostring(eState4.dead))
    end
end