-- Mission 7: Brave New World
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local startAttack = false
local scriptTimer = 0 
local scriptDelay = 5

local lastAttack = 0
local attackNum = 0

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	building.maxTowerCount = 9
	building.defensiveTowerLimit = 6
	building.switchToDefensiveTowerLimit = 6
	waves = {31,32,33,34,35,36,50,51,52,53,54,55,56,57}
	
	--self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	--self:DisableUnitType(UnitType.DWARF)
	--self:DisableUnitType(UnitType.WIZARD)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_07_01)
	self:UnlockUnit(UnitType.GRIFFONRIDER)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_ANIMAL_NEST_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_ANIMAL_NEST_NAME)
	humanPlayer:SetMaxTowerUpgrade(1)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsAchieved() and dialog.dialogIndex < 18 then			-- win conditon
		dialog.dialogIndex = 18
	end

	if lastAttack ~= attack.attackTimer and attackNum < 5 then
		attackNum = attackNum + 1
		lastAttack = attack.attackTimer
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		--if startAttack then 
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)
		--end
		CheckAiMode(self,humanPlayer,enemyPlayer,5,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 550
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	RepeatDialog(self,dialog,humanPlayer)
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_01, StoryChar.ADVISOR,"story_na_level_07_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_02, StoryChar.ROUGEHERO,"story_na_level_07_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_03, StoryChar.ROUGEHERO,"story_na_level_07_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_04, StoryChar.ROUGEHERO,"story_na_level_07_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_05, StoryChar.ADVISOR,"story_na_level_07_ingame_05")
			dialog.dialogIndex = 5
			self:MoveCameraTo( vector3(360,280,0))
		elseif dialog.dialogIndex == 5 then	
			dialog.dialogEnd = true
			scriptDelay = 15
			self:EnableInput()
			dialog.dialogIndex = 6
			
		elseif dialog.dialogIndex == 7 then -- toronyepites utan, upgrade szoveg
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_06, StoryChar.WIZARDHERO,"story_na_level_07_ingame_06")
			self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_07_02)
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			ShowDialog(self,LocID.STORY_NA_LEVEL_07_INGAME_07, StoryChar.WIZARDHERO,"story_na_level_07_ingame_07",LocID.STORY_XBOX_NA_LEVEL_07_INGAME_07,"story_xbox_na_level_07_ingame_07",LocID.STORY_PS3_NA_LEVEL_07_INGAME_07,"story_ps3_na_level_07_ingame_07")
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 9
			
		elseif dialog.dialogIndex == 9.1 then
			ShowDialog(self,LocID.STORY_NA_LEVEL_07_INGAME_08, StoryChar.WIZARDHERO,"story_na_level_07_ingame_08",LocID.STORY_XBOX_NA_LEVEL_07_INGAME_08,"story_xbox_na_level_07_ingame_08",LocID.STORY_PS3_NA_LEVEL_07_INGAME_08,"story_ps3_na_level_07_ingame_08")
			GameApp.SetBlink(true, GuiItemType.UPGRADE_TOWER, 0, vector3(0,0,0))
			dialog.repeatStart = false
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			ShowDialog(self,LocID.STORY_NA_LEVEL_07_INGAME_09, StoryChar.WIZARDHERO,"story_na_level_07_ingame_09",LocID.STORY_XBOX_NA_LEVEL_07_INGAME_09,"story_xbox_na_level_07_ingame_09",LocID.STORY_PS3_NA_LEVEL_07_INGAME_09,"story_ps3_na_level_07_ingame_09")
			startAttack = true
			dialog.repeatStart = true
			dialog.repeatTimer = GameApp.GetServerFrameCount()
			dialog.dialogIndex = 11
			
		elseif dialog.dialogIndex == 12 then --torony upgradehez kiirni
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_10, StoryChar.WIZARDHERO,"story_na_level_07_ingame_10")
			GameApp.SetBlink(false, GuiItemType.UPGRADE_TOWER, 0, vector3(0,0,0))
			self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_07_02)
			dialog.repeatStart = false
			dialog.dialogIndex = 13
			
		elseif dialog.dialogIndex == 13 and attackNum >= 4 then -- 4. wavenel kiirni
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_11, StoryChar.ROUGEHERO,"story_na_level_07_ingame_11")
			dialog.dialogIndex = 15
			
		elseif dialog.dialogEnemyHp == 0 and enemyPlayer:GetCurrentHP() <= 0.25 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_12, StoryChar.ADVISOR,"story_na_level_07_ingame_12")
			dialog.dialogEnemyHp = 1
			
		elseif dialog.dialogIndex == 18 then
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_07_01)
			self:DisplayDialog(LocID.STORY_NA_LEVEL_07_INGAME_13, StoryChar.ADVISOR,"story_na_level_07_ingame_13")
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then
			dialog.dialogIndex = 20
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
		end
	end
end

function UpgradeTowerMenuActivated(self)
	if dialog.dialogIndex == 9 then
		dialog.dialogIndex = 9.1
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 5 then
		dialog.dialogIndex = 5
		startAttack = true
		self:HideDialog()
	end
end

function TowerBuilt(self, playerIndex, towerTypeIndex)
	if playerIndex == 0 and dialog.dialogIndex == 6 then
		if tutorial then
			dialog.dialogIndex = 7
		else
			dialog.dialogIndex = 13
			startAttack = true
		end
	end
end

function TowerUpgraded(self, playerIndex, tower )
	if playerIndex == 0 and dialog.dialogIndex == 11 then
		dialog.dialogIndex = 12
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end

function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
		--CountUnits(self,humanPlayer,class)
		--WeakestTower(self,enemyPlayer,humanPlayer,false)
		--humanPlayer:StopAllUnit()
		--local rand = GameApp.GetRandom(2)
		--self:Print(rand)
		--self:LoseGame()
		--self:MoveCameraTo(pos)
		--humanPlayer:CastSpellInPosition(SpellType.SKYBLAST,pos)
		--for i=1,8 do
		--	self:Print(" Elerte-e a hero hatart: " .. tostring(heroes[i]))
		--end
		--vec3 = enemyPlayer:GetAriseSpellTarget(vec)
		--self:MoveCameraTo(vec3)
		--enemyPlayer:CastSpellInPosition(SpellType.ARISE,vec3)
		--Units(self,humanPlayer,eState,1)
		--RepairTower(self,enemyPlayer)
		--humanPlayer:SendUnit(UnitType.MINOTAURUS,false)
		--humanPlayer:SendUnit(UnitType.IXMIL,false)
		--humanPlayer:SendUnit(UnitType.DEADKING,false)
		--humanPlayer:SendUnit(UnitType.FOXWALDE,false)
		--SellUselessTowers(self,enemyPlayer)
		--enemyPlayer:SetVisible(false)
		--vec3 = enemyPlayer:GetDamageSpellTarget(vec)
		--self:MoveCameraTo(vec3)
		--self:Print(tostring(vec3))
		--self:ShowLastDialog()
	end
	if key == 72 then
		--CountUnits(self,humanPlayer,class)
		--WeakestTower(self,enemyPlayer,humanPlayer,true)
	end
end