-- Mission 8: Where the Wild Things Are
VisionLua.LoadScript("scene\\common_ai.lua")


local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0

local scriptTimer = 0 
local scriptDelay = 5

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	building.maxTowerCount = 11
	building.defensiveTowerLimit = 7
	building.switchToDefensiveTowerLimit = 7
	--spells.spellInterval = 300
	waves = {31,32,33,34,35,35,35,36,37,38,39,50,51,52,53,54,55,56,57}
	--self:DisableUnitType(UnitType.GRIFFONRIDER)
	self:DisableUnitType(UnitType.ELVENARCHER)
	--self:DisableUnitType(UnitType.DWARF)
	--self:DisableUnitType(UnitType.WIZARD)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	--self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_08_01)
	self:UnlockUnit(UnitType.HUMAN_DAMAGE_DOT)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_ANIMAL_NEST_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_ANIMAL_NEST_NAME)
	humanPlayer:SetMaxTowerUpgrade(1)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsAchieved() and dialog.dialogIndex == 6 then			-- win conditon
		dialog.dialogIndex = 7
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,5,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 550
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			AiStop(self,upgrade,building,eState)
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_01, StoryChar.ROUGEHERO,"story_na_level_08_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_02, StoryChar.DWARFHERO,"story_na_level_08_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_03, StoryChar.WIZARDHERO,"story_na_level_08_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_04, StoryChar.ADVISOR,"story_na_level_08_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_05, StoryChar.ADVISOR,"story_na_level_08_ingame_05")
			self:MoveCameraTo( vector3(40,520,0))
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then	
			self:EnableInput()
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			scriptDelay = 15
			dialog.dialogIndex = 6
			
		--victory text
		elseif dialog.dialogIndex == 7 then
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_08_01)
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_06, StoryChar.ROUGEHERO,"story_na_level_08_ingame_06")
			humanPlayer:SetInvulnerable (true)
			enemyPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_07, StoryChar.DWARFHERO,"story_na_level_08_ingame_07")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_08_INGAME_08, StoryChar.ROUGEHERO,"story_na_level_08_ingame_08")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then	
			dialog.dialogIndex = 11
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
		end
	end
end


function SkipStoryActivated(self)
	if dialog.dialogIndex < 5 then
		dialog.dialogIndex = 5
		self:HideDialog()
	end
end

function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
		--spells.spellTimer = spells.spellTimer - 500
			--local pos = vector3(0,0,0)
			--local num = 0
			--num, pos = enemyPlayer:GetKamikazeSpellTarget()
			--self:Print(tostring(num))
			--self:Print(tostring(pos))
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end