-- Mission 11: Take it Back
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local enemy3Player = 0
local enemy4Player = 0

local scriptTimer = 0
local script3Timer = 0
local script4Timer = 0
local scriptDelay = 5

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	enemy3Player = GameApp.GetPlayer(2)
	enemy4Player = GameApp.GetPlayer(3)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	CheckRace(self,enemy3Player,eState3)
	CheckRace(self,enemy4Player,eState4)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	building.maxTowerCount = 12
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	building3.maxTowerCount = 12
	building3.defensiveTowerLimit = 5
	building3.switchToDefensiveTowerLimit = 5
	building4.maxTowerCount = 12
	building4.defensiveTowerLimit = 5
	building4.switchToDefensiveTowerLimit = 5
	waves = {31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,50,51,52,53,54,55,56,57}
	waves3 = {61,62,63,64,65,66,67,68,69,70,71,80,81,82,83,84,85,86,87}
	waves4 = {61,62,63,64,65,66,67,68,69,70,71,80,81,82,83,84,85,86,87}
	
	--self:DisableUnitType(UnitType.GRIFFONRIDER)
	--self:DisableUnitType(UnitType.ELVENARCHER)
	--self:DisableUnitType(UnitType.DWARF)
	--self:DisableUnitType(UnitType.WIZARD)
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	--self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	--self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	--self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_11_01)
	self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_11_02)
	self:UnlockUnit(UnitType.ELVENARCHER)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_NATURE_SANCTUARY_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_NATURE_SANCTUARY_NAME)
	enemy3Player:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemy3Player:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
	enemy4Player:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemy4Player:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
end

function DeInit(self)
end

function Update(self)
	UpdateFSM(self)
end

function Objectives(self,dialog)
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)
	local obj3 = self:GetObjective(2)
	if obj1:IsAchieved() then
		self:LoseGame()
	end
	if obj2:IsAchieved() and obj3:IsAchieved() and dialog.dialogIndex == 9 then			-- win conditon
		dialog.dialogIndex = 10
	end
	
	if (obj2:IsAchieved() or obj3:IsAchieved()) and dialog.dialogEnemyHp == 0 then
		self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_10, StoryChar.DWARFHERO,"story_na_level_11_ingame_10")
		dialog.dialogEnemyHp = 1
	end
end

function UpdateFSM(self)
	Objectives(self,dialog)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	if not eState3.dead and enemy3Player:GetCurrentHP() <= 0 then
		eState3.dead = true
	end
	if not eState4.dead and enemy4Player:GetCurrentHP() <= 0 then
		eState4.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd and current >= scriptTimer + scriptDelay then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if not eState3.dead and dialog.dialogEnd and current >= script3Timer + scriptDelay then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemy3Player,eState3,attack3,unitCost,waves3,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemy3Player,10,eState3,current)
		aiTowers(self,humanPlayer,enemy3Player,building3,eState3,bh3,towerTypes3,current)
		EcoUpgradeCheck(self,enemy3Player,eState3,upgrade3,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemy3Player,eState3,spells3,current)
		UpgradeTowers(self,enemy3Player,building3,eState3,current)
		SendHero(self,enemy3Player,eState3,heroes3,current)
		RepairTower(self,enemy3Player,current)
		--SellUselessTowers(self,enemy3Player,building3,current)
		if eState3.state == eState3.balanced then
			attack3.attackInterval = 800
			building3.buildInterval = 700
		elseif eState3.state == eState3.defensive then
			attack3.attackInterval = 1800
			building3.buildInterval = 300
		elseif eState3.state == eState3.offensive then
			attack3.attackInterval = 333
			building3.buildInterval = 1200
		end
		script3Timer = GameApp.GetServerFrameCount()
	end
	if not eState4.dead and dialog.dialogEnd and current >= script4Timer + scriptDelay then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemy4Player,eState4,attack4,unitCost,waves4,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemy4Player,10,eState4,current)
		aiTowers(self,humanPlayer,enemy4Player,building4,eState4,bh4,towerTypes4,current)
		EcoUpgradeCheck(self,enemy4Player,eState4,upgrade4,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemy4Player,eState4,spells4,current)
		UpgradeTowers(self,enemy4Player,building4,eState4,current)
		SendHero(self,enemy4Player,eState4,heroes4,current)
		RepairTower(self,enemy4Player,current)
		--SellUselessTowers(self,enemy4Player,building4,current)
		if eState4.state == eState4.balanced then
			attack4.attackInterval = 800
			building4.buildInterval = 700
		elseif eState4.state == eState4.defensive then
			attack4.attackInterval = 1800
			building4.buildInterval = 300
		elseif eState4.state == eState4.offensive then
			attack4.attackInterval = 333
			building4.buildInterval = 1200
		end
		script4Timer = GameApp.GetServerFrameCount()
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			AiStop(self,upgrade,building,eState)
			AiStop(self,upgrade3,building3,eState3)
			AiStop(self,upgrade4,building4,eState4)
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_01, StoryChar.ELFHERO,"story_na_level_11_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_02, StoryChar.ELFHERO,"story_na_level_11_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_03, StoryChar.ELFHERO,"story_na_level_11_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_04, StoryChar.ADVISOR,"story_na_level_11_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_05, StoryChar.ADVISOR,"story_na_level_11_ingame_05")
			self:MoveCameraTo( vector3(-520,0,0))
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_06, StoryChar.ADVISOR,"story_na_level_11_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_07, StoryChar.ADVISOR,"story_na_level_11_ingame_07")
			self:MoveCameraTo( vector3(0,520,0))
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_08, StoryChar.ADVISOR,"story_na_level_11_ingame_08")
			self:MoveCameraTo( vector3(0,-520,0))
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then	
			self:EnableInput()
			dialog.dialogEnd = true
			dialog.dialogIndex = 9
			scriptDelay = 15
			AiStart(self,upgrade,building,eState)
			AiStart(self,upgrade3,building3,eState3)
			AiStart(self,upgrade4,building4,eState4)
		
		--victory text
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_11, StoryChar.ADVISOR,"story_na_level_11_ingame_11")
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_11_01)
			self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_11_02)
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			enemy3Player:SetInvulnerable (true)
			enemy4Player:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_12, StoryChar.ELFHERO,"story_na_level_11_ingame_12")
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 13
			
		end
	end
end
	
function HpDialog(self)
	if not self:IsStoryDialogActive() and enemyPlayer:GetCurrentHP() <= 0.5 and dialog.dialogEnemyHp == 0 then
		self:DisplayDialog(LocID.STORY_NA_LEVEL_11_INGAME_09, StoryChar.ELFHERO,"story_na_level_11_ingame_09")
		dialog.dialogEnemyHp = 1
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 8 then
		dialog.dialogIndex = 8
		self:HideDialog()
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end