-- Mission 12: On the Road Again
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local scriptTimer = 0 
local scriptDelay = 5


function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	waves = {61,62,63,64,65,66,67,68,69,70,71,80,81,82,83,84,85,86,87}
	building.maxTowerCount = 12
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	--self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	--self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	--self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_12_01)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsAchieved() and dialog.dialogIndex == 22 then --win condition
		dialog.dialogIndex = 23
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	-- start text
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_01, StoryChar.ELFHERO,"story_na_level_12_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_02, StoryChar.ADVISOR,"story_na_level_12_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_03, StoryChar.ELFHERO,"story_na_level_12_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_04, StoryChar.ADVISOR,"story_na_level_12_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_05, StoryChar.ELFHERO,"story_na_level_12_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_06, StoryChar.ELFHERO,"story_na_level_12_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_07, StoryChar.DWARFHERO,"story_na_level_12_ingame_07")
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_08, StoryChar.ELFHERO,"story_na_level_12_ingame_08")
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_09, StoryChar.ELFHERO,"story_na_level_12_ingame_09")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_10, StoryChar.ELFHERO,"story_na_level_12_ingame_10")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_11, StoryChar.DWARFHERO,"story_na_level_12_ingame_11")
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_12, StoryChar.ELFHERO,"story_na_level_12_ingame_12")
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_13, StoryChar.ELFHERO,"story_na_level_12_ingame_13")
			dialog.dialogIndex = 13
		elseif dialog.dialogIndex == 13 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_14, StoryChar.ADVISOR,"story_na_level_12_ingame_14")
			dialog.dialogIndex = 14
		elseif dialog.dialogIndex == 14 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_15, StoryChar.ELFHERO,"story_na_level_12_ingame_15")
			dialog.dialogIndex = 15
		elseif dialog.dialogIndex == 15 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_16, StoryChar.WIZARDHERO,"story_na_level_12_ingame_16")
			dialog.dialogIndex = 16
		elseif dialog.dialogIndex == 16 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_17, StoryChar.WIZARDHERO,"story_na_level_12_ingame_17")
			dialog.dialogIndex = 17
		elseif dialog.dialogIndex == 17 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_18, StoryChar.DWARFHERO,"story_na_level_12_ingame_18")
			dialog.dialogIndex = 18
		elseif dialog.dialogIndex == 18 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_19, StoryChar.ELFHERO,"story_na_level_12_ingame_19")
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_20, StoryChar.ELFHERO,"story_na_level_12_ingame_20")
			dialog.dialogIndex = 20
		elseif dialog.dialogIndex == 20 then
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_21, StoryChar.ELFHERO,"story_na_level_12_ingame_21")
			dialog.dialogIndex = 21
		elseif dialog.dialogIndex == 21 then
			dialog.dialogEnd = true
			scriptDelay = 15
			self:EnableInput()
			dialog.dialogIndex = 22
			
		elseif dialog.dialogIndex == 23 then
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_12_01)
			self:DisplayDialog(LocID.STORY_NA_LEVEL_12_INGAME_22, StoryChar.DWARFHERO,"story_na_level_12_ingame_22")
			dialog.dialogIndex = 24
		elseif dialog.dialogIndex == 24 then	
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 25
		end
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 21 then
		dialog.dialogIndex = 21
		self:HideDialog()
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end

function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
		WeakestTower(self,enemyPlayer,building)
	end
end