-- Mission 13: Fear of the Dark
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0

local scriptTimer = 0 
local scriptDelay = 5
local meteorName = "graphic/effect/meteor_impact.xml"
local meteorDecal = "graphic/effect/meteor_impact.xml"
local meteorTimer = 0
local meteorDelay = 200
local meteorRandom = GameApp.GetRandom(300,"meteor_random_time")
local meteorCount = 0

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	waves = {61,62,63,64,65,66,67,68,69,70,71,80,81,82,83,84,85,86,87}
	building.maxTowerCount = 10
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	--self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	--self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	--self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	--self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_13_01)
	self:UnlockEconomy(UpgradeType.CHEAPER_SPELLS)
	self:UnlockSpell(SpellType.COLLECTHUM)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	local current = GameApp.GetServerFrameCount()
	if obj1:IsAchieved() and dialog.dialogIndex == 6 then
		dialog.dialogIndex = 7
	end
	if current >= meteorTimer + meteorDelay + meteorRandom then
		MeteorStorm(self)
		meteorCount = meteorCount + 1
		if meteorCount >= 6 then
			meteorCount = 0
			meteorTimer = GameApp.GetServerFrameCount()
			meteorRandom = GameApp.GetRandom(300,"next_meteor_time")
		end
	end
end

function MeteorStorm(self)
	local x = GameApp.GetRandom(16,"meteor_x_coord")
	local y = GameApp.GetRandom(24,"meteor_x_coord")
	local pos = vector3(0,0,0)
	pos.x = (x*40) - 240
	pos.y = (y*40) - 520
	--self:Print(pos.x)
	--self:Print(pos.y)
	VisionGame.CreateParticleEffect( meteorName, pos,  vector3(0,-90,0) )
	GameApp.RadiusDamage(100, 60, pos)
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 800
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	-- start text
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_01, StoryChar.DWARFHERO,"story_un_level_13_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_02, StoryChar.DWARFHERO,"story_un_level_13_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_03, StoryChar.ELFHERO,"story_un_level_13_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_04, StoryChar.WIZARDHERO,"story_un_level_13_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_05, StoryChar.ADVISOR,"story_un_level_13_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			dialog.dialogEnd = true
			scriptDelay = 15
			self:EnableInput()
			dialog.dialogIndex = 6
			
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_06, StoryChar.ADVISOR,"story_un_level_13_ingame_06")
			humanPlayer:SetInvulnerable (true)
			enemyPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_13_01)
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_07, StoryChar.ELFHERO,"story_un_level_13_ingame_07")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then	
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 10
		end
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 5 then
		dialog.dialogIndex = 5
		self:HideDialog()
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end

function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
		MeteorStorm(self)
	end
end