-- Mission 15: Temple of Wisdom
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0

local scriptTimer = 0 
local scriptDelay = 5

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	waves = {61,62,63,64,65,66,67,68,69,70,71,72,73,73,73,73,74,80,81,82,83,84,85,86,87}
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	
	--self:DisableUnitType(UnitType.HUMAN_BLOCK)
	--self:DisableUnitType(UnitType.HUMAN_DEBUFF_SLOW)
	--self:DisableUnitType(UnitType.HUMAN_DAMAGE_DOT)
	--self:DisableUnitType(UnitType.HUMAN_BUFF_RESOURCE)
	--self:DisableUnitType(UnitType.HUMAN_DAMAGE_RECHARGE)
	
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	--self:DisableSpellType(SpellType.FROZENSHIELD)
	self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	--self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	--self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_15_01)
	self:UnlockUnit(UnitType.HUMAN_DAMAGE_RECHARGE)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_TEMPLE_OF_KNOWLEDGE_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_TEMPLE_OF_KNOWLEDGE_NAME)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsAchieved() and dialog.dialogIndex == 10 then			-- win conditon
		dialog.dialogIndex = 11
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			AiStop(self,upgrade,building,eState)
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_01, StoryChar.WIZARDHERO,"story_un_level_15_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_02, StoryChar.DWARFHERO,"story_un_level_15_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_03, StoryChar.ROUGEHERO,"story_un_level_15_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_04, StoryChar.WIZARDHERO,"story_un_level_15_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_05, StoryChar.ELFHERO,"story_un_level_15_ingame_05")
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_06, StoryChar.WIZARDHERO,"story_un_level_15_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_07, StoryChar.DWARFHERO,"story_un_level_15_ingame_07")
			self:EnableInput()
			enemyPlayer:SendUnit(UnitType.VAMPIRE,false)
			enemyPlayer:SendUnit(UnitType.VAMPIRE,false)
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_08, StoryChar.ELFHERO,"story_un_level_15_ingame_08")
			self:MoveCameraTo(vector3(-160,160,0))
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_09, StoryChar.DWARFHERO,"story_un_level_15_ingame_09")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			scriptDelay = 15
			dialog.dialogIndex = 10
			
		--victory text
		elseif dialog.dialogIndex == 11 then
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_15_01)
			self:DisplayDialog(LocID.STORY_UN_LEVEL_15_INGAME_10, StoryChar.WIZARDHERO,"story_un_level_15_ingame_10")
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 13
			
		end
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 9 then
		dialog.dialogIndex = 9
		enemyPlayer:SendUnit(UnitType.VAMPIRE)
		enemyPlayer:SendUnit(UnitType.VAMPIRE)
		self:EnableInput()
		self:HideDialog()
	end
end


function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end