-- Mission 16: Valley of Death
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local enemy3Player = 0

local scriptTimer = 0 
local scriptDelay = 5

local damageHuman = true
local damageEnemy = true
local totalHp = 0
local demonTimer = 0
local balrog = nil

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	enemy3Player = GameApp.GetPlayer(2)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	enemy3Player:SetMinimapHPIconVisible(false)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	waves = {61,62,63,64,65,66,67,68,69,70,71,72,73,74,80,81,82,83,84,85,86,87}
	enemy3Player:SetInvulnerable (true)
	building.maxTowerCount = 11
	building.defensiveTowerLimit = 7
	building.switchToDefensiveTowerLimit = 7
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	--self:DisableSpellType(SpellType.FROZENSHIELD)
	--self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	--self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	--self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	local player2 = GameApp.GetPlayer(2)
	player2:SetDescriptionLocID(LocID.STORY_UN_LEVEL_16_DAEMON_DESC)
	player2:SetBaseIconFileName("graphic/gui/ingame/underworld/big/unit/info_human_unit_demon.dds")
	player2:SetDisabledBaseIconFileName("graphic/gui/ingame/underworld/big/unit/info_human_unit_demon.dds")

	self:AttachEffectEntityToEntityBone( "Balrog", "headfire_bone", "", "graphic/effect/balrog_fire_head_sm.xml", "demon_fire_1" )
	self:AttachEffectEntityToEntityBone( "Balrog", "elbow_bone1", 	"", "graphic/effect/balrog_fire_elbow_sm.xml", "demon_fire_2" )
	self:AttachEffectEntityToEntityBone( "Balrog", "elbow_bone2",		"", "graphic/effect/balrog_fire_elbow_sm.xml", "demon_fire_3" )
	
	self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone1", "", "graphic/effect/balrog_base.xml", "baselight1" )
	self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone2", "", "graphic/effect/balrog_base.xml", "baselight2" )
	self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone3", "", "graphic/effect/balrog_base.xml", "baselight3" )
	self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone4", "", "graphic/effect/balrog_base.xml", "baselight4" )
	self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone5", "", "graphic/effect/balrog_base.xml", "baselight5" )
	self:AttachEffectEntityToEntityBone( "Balrog", "baselight_bone6", "", "graphic/effect/balrog_base.xml", "baselight6" )
	
	balrog = VisionGame.GetEntity("Balrog")
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_16_01)
	self:UnlockSpell(SpellType.TEST)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
	enemy3Player:SetDescriptionLocID(LocID.LOC_NMY_DAEMON_DESC)
	enemy3Player:SetNameLocID(LocID.LOC_NMY_DAEMON_NAME)
end

function DeInit(self)
end

function Update(self)
	local current = GameApp.GetServerFrameCount()
	if current >= scriptTimer + scriptDelay then
		UpdateFSM(self)
		scriptTimer = GameApp.GetServerFrameCount()
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	if obj1:IsAchieved() and dialog.dialogIndex <= 17 then			-- win conditon
		dialog.dialogIndex = 18
	end
	
	local current = GameApp.GetServerFrameCount()
	if current >= demonTimer + 1800 then
		
		self:SetTimer(0,1800,true,LocID.LOC_TIMER_DAEMON)
		demonTimer = GameApp.GetServerFrameCount()
		--self:Print("demon sebez")
		if balrog ~= nil then
			balrog:Attack()
		end
		if dialog.dialogIndex == 13 then
			dialog.dialogIndex = 14
		end
		if damageHuman then
			humanPlayer:DamageToAllUnit(100)
		else
			damageHuman = true
		end
		if damageEnemy then
			enemyPlayer:DamageToAllUnit(100)
		else
			damageEnemy = true
		end
	end
	
	if totalHp > 3600 and demonTimer < 999999 then
		if dialog.dialogIndex <= 15 then
			dialog.dialogIndex = 16
		end
		humanPlayer:DamageToAllUnit(400)
		humanPlayer:DamageToAllTower(400)
		enemyPlayer:DamageToAllUnit(400)
		enemyPlayer:DamageToAllTower(400)
		demonTimer = 999999
		--self:Print("elszabadult a demon")
		enemy3Player:SetPlayerTeam(0)
		humanPlayer:SetCurrentEnemy(1)
		humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		self:SetTimer(0,0,true,-1)
		--local balrogEntity = VisionGame.GetEntity("Balrog")
		--self:MoveCameraTo(balrogEntity:GetPosition())
		--balrogEntity:StartSkeletalAnimation("breakfree1")
		if balrog ~= nil then
			balrog:Sacrifice()
		end
	end
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 800
			building.buildInterval = 700
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1800
			building.buildInterval = 200
		elseif eState.state == eState.offensive then
			attack.attackInterval = 333
			building.buildInterval = 900
		end
	end
end

function UnitDamagedToBase(self, playerIndex, unitTypeIndex, targetPlayer, hp)
	--self:Print("beert ehhez a playerhez: " ..playerIndex .. ",ez a player: " .. targetPlayer)
	--self:Print(unitTypeIndex)
	if playerIndex == 2 and targetPlayer == 0 then
		damageHuman = false
		totalHp = totalHp + hp
		--self:Print(totalHp)
	end
	--dialog.dialogIndex = 99	
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			self:DisableInput()
			demonTimer = 99999
			AiStop(self,upgrade,building,eState)
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_01, StoryChar.ROUGEHERO,"story_un_level_16_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_02, StoryChar.WIZARDHERO,"story_un_level_16_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_03, StoryChar.DWARFHERO,"story_un_level_16_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_04, StoryChar.ADVISOR,"story_un_level_16_ingame_04")
			dialog.dialogIndex = 4
		elseif dialog.dialogIndex == 4 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_05, StoryChar.DAEMON,"story_un_level_16_ingame_05")
			self:MoveCameraTo( vector3(190,20,0))
			dialog.dialogIndex = 5
		elseif dialog.dialogIndex == 5 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_06, StoryChar.WIZARDHERO,"story_un_level_16_ingame_06")
			dialog.dialogIndex = 6
		elseif dialog.dialogIndex == 6 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_07, StoryChar.ELFHERO,"story_un_level_16_ingame_07")
			dialog.dialogIndex = 7
		elseif dialog.dialogIndex == 7 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_08, StoryChar.DAEMON,"story_un_level_16_ingame_08")
			dialog.dialogIndex = 8
		elseif dialog.dialogIndex == 8 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_09, StoryChar.ELFHERO,"story_un_level_16_ingame_09")
			dialog.dialogIndex = 9
		elseif dialog.dialogIndex == 9 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_10, StoryChar.DAEMON,"story_un_level_16_ingame_10")
			dialog.dialogIndex = 10
		elseif dialog.dialogIndex == 10 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_11, StoryChar.ELFHERO,"story_un_level_16_ingame_11")
			dialog.dialogIndex = 11
		elseif dialog.dialogIndex == 11 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_12, StoryChar.DAEMON,"story_un_level_16_ingame_12")
			dialog.dialogIndex = 12
		elseif dialog.dialogIndex == 12 then
			AiStart(self,upgrade,building,eState)
			dialog.dialogEnd = true
			demonTimer = GameApp.GetServerFrameCount()
			self:SetTimer(0,1800,true,LocID.LOC_TIMER_DAEMON)
			scriptDelay = 15
			self:EnableInput()
			dialog.dialogIndex = 13
		
		elseif dialog.dialogIndex == 14 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_13, StoryChar.ADVISOR,"story_un_level_16_ingame_13")
			dialog.dialogIndex = 15
			
		elseif dialog.dialogIndex == 16 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_14, StoryChar.DAEMON,"story_un_level_16_ingame_14")
			dialog.dialogIndex = 17
			
		--victory text
		elseif dialog.dialogIndex == 18 then
			if demonTimer < 90000 then
				self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_15, StoryChar.DAEMON,"story_un_level_16_ingame_15")
			end
			self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_16_01)
			enemyPlayer:SetInvulnerable (true)
			humanPlayer:SetInvulnerable (true)
			self:DisableInput()
			humanPlayer:StopAllUnit()
			dialog.dialogIndex = 19
		elseif dialog.dialogIndex == 19 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_16_INGAME_16, StoryChar.ADVISOR,"story_un_level_16_ingame_16")
			dialog.dialogIndex = 20
		elseif dialog.dialogIndex == 20 then
			self:EnableInput()
			self:WinGame(humanPlayerIndex)
			dialog.dialogIndex = 21
		end
	end
end


function KeyDown(self, key)
	--self:Print(key)
	if key == 66 then
		--self:Print(tostring(buildh[1]))
		--self:Print(dialog.dialogIndex)
		--local balrogEntity = VisionGame.GetEntity("Balrog")
		---self:MoveCameraTo(balrogEntity:GetPosition())
		--balrogEntity:StartSkeletalAnimation("breakfree1")
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 12 then
		dialog.dialogIndex = 12
		self:HideDialog()
		demonTimer = GameApp.GetServerFrameCount()
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end