-- Mission 17: Three Kings
VisionLua.LoadScript("scene\\common_ai.lua")

local humanPlayerIndex = 0
local humanPlayer = 0
local enemyPlayer = 0
local enemy3Player = 0
local enemy4Player = 0

local scriptTimer = 0
local script3Timer = 0
local script4Timer = 0
local scriptDelay = 5
local wizards = {true,true,true}
local wizardsSent = {false,false,false}
local counter = {0,0,0,0}

function Init(self)
	humanPlayer = GameApp.GetPlayer(0)
	enemyPlayer = GameApp.GetPlayer(1)
	enemy3Player = GameApp.GetPlayer(2)
	enemy4Player = GameApp.GetPlayer(3)
	PlayerNumberInit(self)
	CheckRace(self,enemyPlayer,eState)
	CheckRace(self,enemy3Player,eState3)
	CheckRace(self,enemy4Player,eState4)
	RefreshUnitCost(self,enemyPlayer,unitCost)
	self:SetMissionMode(MissionMode.CAMPAIGN)
	enemyPlayer:DisableDie(true)
	enemy3Player:DisableDie(true)
	enemy4Player:DisableDie(true)
	waves = {61,62,63,64,65,66,67,68,69,70,70,70,70,71,71,71,71,72,73,74,75,76,80,81,82,83,84,85,86,87}
	waves3 = {61,62,63,64,65,66,67,68,69,70,70,70,70,71,71,71,71,72,73,74,75,76,80,81,82,83,84,85,86,87}
	waves4 = {61,62,63,64,65,66,67,68,69,70,70,70,70,71,71,71,71,72,73,74,75,76,80,81,82,83,84,85,86,87}
	upgrade.upgradeInterval = 3900
	upgrade3.upgradeInterval = 3900
	upgrade4.upgradeInterval = 3900
	building.upgradeInterval = 1900
	building3.upgradeInterval = 1900
	building4.upgradeInterval = 1900
	spells.spellRepairInterval = 2700
	spells.spellInterval = 2500
	spells3.spellRepairInterval = 2700
	spells3.spellInterval = 2500
	spells4.spellRepairInterval = 2700
	spells4.spellInterval = 2500
	building.maxTowerCount = 8
	building.defensiveTowerLimit = 5
	building.switchToDefensiveTowerLimit = 5
	building3.maxTowerCount = 8
	building3.defensiveTowerLimit = 5
	building3.switchToDefensiveTowerLimit = 5
	building4.maxTowerCount = 8
	building4.defensiveTowerLimit = 5
	building4.switchToDefensiveTowerLimit = 5
	--self:DisableSpellType(SpellType.THUNDERBOLT)
	--self:DisableSpellType(SpellType.FROZENSHIELD)
	--self:DisableSpellType(SpellType.TEST)
	--self:DisableSpellType(SpellType.REPAIRHUM)
	--self:DisableSpellType(SpellType.COLLECTHUM)
	
	--self:DisableUpgradeType(UpgradeType.UNIT_POOL_UPGRADE)
	--self:DisableUpgradeType(UpgradeType.XP_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_BONUS)
	--self:DisableUpgradeType(UpgradeType.RESOURCE_REPLENISH)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UPGRADES)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_SPELLS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_UNITS)
	--self:DisableUpgradeType(UpgradeType.CHEAPER_TOWERS)
	self:SetObjectiveText(0, 1, LocID.LOC_OBJ_LEVEL_17_01)
	enemyPlayer:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemyPlayer:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
	enemy3Player:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemy3Player:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
	enemy4Player:SetDescriptionLocID(LocID.LOC_NMY_DARK_TEMPLE_DESC)
	enemy4Player:SetNameLocID(LocID.LOC_NMY_DARK_TEMPLE_NAME)
end

function DeInit(self)
end

function Update(self)
	UpdateFSM(self)
end

function UpdateFSM(self)
	Objectives(self)
	DialogTiming(self)
	if not eState.dead and enemyPlayer:GetCurrentHP() <= 0 then
		eState.dead = true
	end
	if not eState3.dead and enemy3Player:GetCurrentHP() <= 0 then
		eState3.dead = true
	end
	if not eState4.dead and enemy4Player:GetCurrentHP() <= 0 then
		eState4.dead = true
	end
	local current = GameApp.GetServerFrameCount()
	if not eState.dead and dialog.dialogEnd and current >= scriptTimer + scriptDelay then -- semmit ne csinaljon a kezdo dialog vegeig
		aiAttack(self,enemyPlayer,eState,attack,unitCost,waves,current)  -- state fuggetlen dolgok
		CheckAiMode(self,humanPlayer,enemyPlayer,10,eState,current)
		aiTowers(self,humanPlayer,enemyPlayer,building,eState,buildh,towerTypes,current)
		EcoUpgradeCheck(self,enemyPlayer,eState,upgrade,current)
		--HpDialog(self)
		aiSpells(self,humanPlayer,enemyPlayer,eState,spells,current)
		UpgradeTowers(self,enemyPlayer,building,eState,current)
		SendHero(self,enemyPlayer,eState,heroes,current)
		RepairTower(self,enemyPlayer,current)
		--SellUselessTowers(self,enemyPlayer,building,current)
		if eState.state == eState.balanced then
			attack.attackInterval = 900
			building.buildInterval = 800
		elseif eState.state == eState.defensive then
			attack.attackInterval = 1900
			building.buildInterval = 300
		elseif eState.state == eState.offensive then
			attack.attackInterval = 633
			building.buildInterval = 900
		end
		scriptTimer = GameApp.GetServerFrameCount()
	end
	if eState.playerNumb == 4 then
		if not eState3.dead and dialog.dialogEnd and current >= script3Timer + scriptDelay +2 then
			aiAttack(self,enemy3Player,eState3,attack3,unitCost,waves,current)  -- state fuggetlen dolgok
			CheckAiMode(self,humanPlayer,enemy3Player,10,eState3,current)
			aiTowers(self,humanPlayer,enemy3Player,building3,eState3,bh3,towerTypes3,current)
			EcoUpgradeCheck(self,enemy3Player,eState3,upgrade3,current)
			--HpDialog(self)
			aiSpells(self,humanPlayer,enemy3Player,eState3,spells3,current)
			UpgradeTowers(self,enemy3Player,building3,eState3,current)
			SendHero(self,enemy3Player,eState3,heroes3,current)
			RepairTower(self,enemy3Player,current)
			--SellUselessTowers(self,enemy3Player,building3,current)
			if eState3.state == eState3.balanced then
				attack3.attackInterval = 900
				building3.buildInterval = 800
			elseif eState3.state == eState3.defensive then
				attack3.attackInterval = 1900
				building3.buildInterval = 300
			elseif eState3.state == eState3.offensive then
				attack3.attackInterval = 633
				building3.buildInterval = 900
			end
			script3Timer = GameApp.GetServerFrameCount()
		end
		if not eState4.dead and dialog.dialogEnd and current >= script4Timer + scriptDelay +4 then
			aiAttack(self,enemy4Player,eState4,attack4,unitCost,waves,current)  -- state fuggetlen dolgok
			CheckAiMode(self,humanPlayer,enemy4Player,10,eState4,current)
			aiTowers(self,humanPlayer,enemy4Player,building4,eState4,bh4,towerTypes4,current)
			EcoUpgradeCheck(self,enemy4Player,eState4,upgrade4,current)
			--HpDialog(self)
			aiSpells(self,humanPlayer,enemy4Player,eState4,spells4,current)
			UpgradeTowers(self,enemy4Player,building4,eState4,current)
			SendHero(self,enemy4Player,eState4,heroes4,current)
			RepairTower(self,enemy4Player,current)
			--SellUselessTowers(self,enemy4Player,building4,current)
			if eState4.state == eState4.balanced then
				attack4.attackInterval = 900
				building4.buildInterval = 800
			elseif eState4.state == eState4.defensive then
				attack4.attackInterval = 1900
				building4.buildInterval = 300
			elseif eState4.state == eState4.offensive then
				attack4.attackInterval = 633
				building4.buildInterval = 900
			end
			script4Timer = GameApp.GetServerFrameCount()
		end
	end
end

function Objectives(self)
	local obj1 = self:GetObjective(0)
	local obj2 = self:GetObjective(1)
	local obj3 = self:GetObjective(2)
	--if obj1:IsAchieved() and obj2:IsAchieved() and obj3:IsAchieved() then			-- win conditon
		--self:WinGame(humanPlayerIndex)
	--end

	--if humanPlayer:GetCurrentHP() <= 0 then   -- lose condition
		--self:LoseGame()
	--end
	if enemyPlayer:GetCurrentHP() <= 0.2 and enemy3Player:GetCurrentHP() <= 0.2 and enemy4Player:GetCurrentHP() <= 0.2 then
		self:SetObjectiveText(0, 2, LocID.LOC_OBJ_LEVEL_17_01)
	end
	if enemyPlayer:GetCurrentHP() ~= 0 and enemyPlayer:GetCurrentHP() <= 0.2 then
		enemyPlayer:SendUnit(UnitType.DAEMON,false)
		enemyPlayer:SendUnit(UnitType.DEADKING,false)
		self:DisplayDialog(LocID.STORY_UN_LEVEL_17_INGAME_04, StoryChar.DWARFHERO,"story_un_level_17_ingame_04")
		self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_17_02)
		eState.dead = true
		obj1:Activate(false)
		enemyPlayer:SetAttackable(false)
		--enemyPlayer:DamageToAllUnit(1400)
		enemyPlayer:DamageToAllTower(1400)
		enemyPlayer:SetCurrentHP(0)
		if eState3.dead == false then
			humanPlayer:SetCurrentEnemy(2)
			humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		elseif eState4.dead == false then
			humanPlayer:SetCurrentEnemy(3)
			humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		end
	end
	
	if enemy3Player:GetCurrentHP() ~= 0 and enemy3Player:GetCurrentHP() <= 0.2 then
		enemy3Player:SendUnit(UnitType.DAEMON,false)
		enemy3Player:SendUnit(UnitType.DEADKING,false)
		self:DisplayDialog(LocID.STORY_UN_LEVEL_17_INGAME_05, StoryChar.ELFHERO,"story_un_level_17_ingame_05")
		self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_17_02)
		eState3.dead = true
		enemy3Player:SetAttackable(false)
		--enemy3Player:DamageToAllUnit(1400)
		enemy3Player:DamageToAllTower(1400)
		enemy3Player:SetCurrentHP(0)
		if eState.dead == false then
			humanPlayer:SetCurrentEnemy(1)
			humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		elseif eState4.dead == false then
			humanPlayer:SetCurrentEnemy(3)
			humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		end
	end
	
	if enemy4Player:GetCurrentHP() ~= 0 and enemy4Player:GetCurrentHP() <= 0.2 then
		enemy4Player:SendUnit(UnitType.DAEMON,false)
		enemy4Player:SendUnit(UnitType.DEADKING,false)
		self:DisplayDialog(LocID.STORY_UN_LEVEL_17_INGAME_06, StoryChar.ROUGEHERO,"story_un_level_17_ingame_06")
		self:SetObjectiveText(1, 1, LocID.LOC_OBJ_LEVEL_17_02)
		eState4.dead = true
		enemy4Player:SetAttackable(false)
		--enemy4Player:DamageToAllUnit(1400)
		enemy4Player:DamageToAllTower(1400)
		enemy4Player:SetCurrentHP(0)
		if eState3.dead == false then
			humanPlayer:SetCurrentEnemy(2)
			humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		elseif eState.dead == false then
			humanPlayer:SetCurrentEnemy(1)
			humanPlayer:MoveUnitsToTheCurrentEnemyBase()
		end
	end
	
	if eState.dead and enemyPlayer:HasUnit(UnitType.DEADKING) then
		wizardsSent[1] = true
	end
	
	if eState3.dead and enemy3Player:HasUnit(UnitType.DEADKING) then
		wizardsSent[2] = true
	end
	
	if eState4.dead and enemy4Player:HasUnit(UnitType.DEADKING) then
		wizardsSent[3] = true
	end
	
	if wizards[1] and wizardsSent[1] then
		if not enemyPlayer:HasUnit(UnitType.DEADKING) then
			counter[1] = counter[1] + 1
			--self:Print("counter 1: " .. counter[1])
			if counter[1] > 20 then
				wizards[1] = false
			end
		end
	end
	if wizards[2] and wizardsSent[2] then
		if not enemy3Player:HasUnit(UnitType.DEADKING) then
			counter[2] = counter[2] + 1
			--self:Print("counter 2: " .. counter[2])
			if counter[2] > 20 then
				wizards[2] = false
			end
		end
	end
	if wizards[3] and wizardsSent[3] then
		if not enemy4Player:HasUnit(UnitType.DEADKING) then
			counter[3] = counter[3] + 1
			--self:Print("counter 3: " .. counter[3])
			if counter[3] > 20 then
				wizards[3] = false
			end
		end
	end
	if not wizards[1] and not wizards[2] and not wizards[3] then
		self:SetObjectiveText(1, 2, LocID.LOC_OBJ_LEVEL_17_02)
		dialog.dialogIndex = 5
	end
end

function UnitDamagedToBase(self, playerIndex, unitTypeIndex, targetPlayer)
	if playerIndex == 0 and unitTypeIndex == 56 then
		self:LoseGame()
	end
end

function DialogTiming(self)
	local current = GameApp.GetServerFrameCount()
	if not self:IsStoryDialogActive() and current >= attack.timer + 30 then
		if dialog.dialogIndex == 0 then
			AiStop(self,upgrade,building,eState)
			AiStop(self,upgrade3,building3,eState3)
			AiStop(self,upgrade4,building4,eState4)
			self:DisableInput()
			self:DisplayDialog(LocID.STORY_UN_LEVEL_17_INGAME_01, StoryChar.ROUGEHERO,"story_un_level_17_ingame_01")
			dialog.dialogIndex = 1
		elseif dialog.dialogIndex == 1 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_17_INGAME_02, StoryChar.WIZARDHERO,"story_un_level_17_ingame_02")
			dialog.dialogIndex = 2
		elseif dialog.dialogIndex == 2 then
			self:DisplayDialog(LocID.STORY_UN_LEVEL_17_INGAME_03, StoryChar.ADVISOR,"story_un_level_17_ingame_03")
			dialog.dialogIndex = 3
		elseif dialog.dialogIndex == 3 then
			dialog.dialogEnd = true
			scriptDelay = 13
			self:EnableInput()
			AiStart(self,upgrade,building,eState)
			AiStart(self,upgrade3,building3,eState3)
			AiStart(self,upgrade4,building4,eState4)
			dialog.dialogIndex = 4
			
		elseif dialog.dialogIndex == 5 then
			humanPlayer:StopAllUnit()
			self:DisplayDialog(LocID.STORY_UN_LEVEL_13_INGAME_06, StoryChar.ADVISOR,"story_un_level_13_ingame_06")
			dialog.dialogIndex = 6
			self:WinGame(humanPlayerIndex)
		end
	end
end

function SkipStoryActivated(self)
	if dialog.dialogIndex < 3 then
		dialog.dialogIndex = 3
		self:HideDialog()
	end
end

function PlayerDied(self,player)
	if player == 0 then
		self:LoseGame()
	end
end